#ifndef MARKSPACERATIOALGORITHM_H
#define MARKSPACERATIOALGORITHM_H

#include "AnalysisAlgorithm.h"
#include "SctData/MarkSpaceRatioTestResult.h"

namespace SctAnalysis {
    /**
       Algorithm for MarkSpaceRatio Test.
    */
class MarkSpaceRatioAlgorithm : public AnalysisAlgorithm {
public:
    virtual bool canAnalyze() const;
    virtual void analyze();
    virtual void loadData();
    virtual shared_ptr<SctData::TestResult> createTestResult() const;
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(shared_ptr<const TestData> testData, const string& moduleName) const throw();
    /** 
	constructor 
     */
    MarkSpaceRatioAlgorithm(shared_ptr<const TestData> testData, const string& moduleName, const AnalysisAlgorithm& alg) throw() : AnalysisAlgorithm(testData, moduleName, alg) {}
    /** 
	destructor 
     */
    virtual ~MarkSpaceRatioAlgorithm() throw() {}    
protected:
    virtual double getAverageOccupancy(const SctData::RawScanResult& raw, unsigned short ilink);
private:
    MarkSpaceRatioAlgorithm() {}
    static bool inMap;
    void fixOptimum(SctData::MarkSpaceRatioTestResult& r);
};
}

#endif //MARKSPACERATIOALGORITHM_H
