#include "IONameDB.h"

namespace SctArchiving {

IONameDB::IONameDB(const string& name) throw(Sct::InvalidArgument) : Sct::IOName(name) {
    IONameDB::parse();
}

IONameDB::IONameDB(const Sct::UniqueID& uniqueID, const string& className) throw() : Sct::IOName(uniqueID, className) {
    IONameDB::construct();
}

IONameDB::~IONameDB() throw() {
}

IONameDB::IONameDB() {
}


void IONameDB::parse() throw(Sct::InvalidArgument) {
    int dot = nameIO.find('.');
    className = nameIO.substr(0, dot);  //ClassName is everything between the last / and second .
    uniqueID = Sct::UniqueID(nameIO.substr(++dot));
}

void IONameDB::construct() throw() {
    nameIO = className;
    nameIO += "." + (string)uniqueID;
}
}

