#include "../IONameDB.h"
#include "IONameDB_Test.h"
namespace SctArchiving{  
  void checkParse(){
    IONameDB name("MyClass::Class.101.3.not_a_module");
    BOOST_CHECK_EQUAL(name.getClassName(),"MyClass::Class");
    Sct::UniqueID id= name.getUniqueID();
    BOOST_CHECK_EQUAL(id.getRunNumber(),101);
    BOOST_CHECK_EQUAL(id.getScanNumber(),3);
    BOOST_CHECK_EQUAL(id.getModule(),"not_a_module");
  }

  void checkConstruct(){
    Sct::UniqueID id1("102.6.still_not_a_module");
    IONameDB name(id1, "MyClass::AnotherClass");
    BOOST_CHECK_EQUAL(name.getClassName(),"MyClass::AnotherClass");
    Sct::UniqueID id2= name.getUniqueID();
    BOOST_CHECK_EQUAL((string)id1,(string)id2);
  }

  IONameDB_Test::IONameDB_Test(){
    add (BOOST_TEST_CASE(&checkParse));
    add (BOOST_TEST_CASE(&checkConstruct));
  }
}
