#include "MarkSpaceRatioConfigUpdater.h"
#include "ConfigUpdaterManager.h"
#include "../SctApiAccessException.h"
#include "../SctApiCall.h"

#include "Sct_SctApi/SctApi.hh"
#include "Sct/SctParameters.h"
#include "Sct/SctNames.h"
#include "SctData/MarkSpaceRatioTestResult.h"
#include "Sct/AbcdScans.h"
#include "SctApi/utility.h"

using namespace Sct;
using namespace SctData;

namespace SctCalibrationController {

bool MarkSpaceRatioConfigUpdater::inMap = ConfigUpdaterManager::instance().setUpdater("SctData::MarkSpaceRatioTestResult", shared_ptr<ConfigUpdater> (new MarkSpaceRatioConfigUpdater()));

void MarkSpaceRatioConfigUpdater::update(const TestResult& testresult, Sct_SctApi::SctApiIPC_ptr api) const {
    const MarkSpaceRatioTestResult& t = dynamic_cast<const MarkSpaceRatioTestResult&> (testresult);

    unsigned long mid = getMID(t, api);

    std::cout << "Modifying ST_TX_MARKSPACE of mid=" << mid << " to value " << (int)floor(t.getOptimum()+0.5) << std::endl;
    APICALL(api, modifyABCDModuleVar(mid, ST_TX_MARKSPACE, (int)floor(t.getOptimum()+0.5)), "MarkSpaceRatioConfigUpdater failed to set API")
}
    
}
