#ifndef SCT_CALIBRATION_CONTROLER_ISINFO_WRAPPER_H
#define SCT_CALIBRATION_CONTROLER_ISINFO_WRAPPER_H
#include "Sct/Serializable.h"
#include <boost/shared_ptr.hpp>

class ISInfo;

namespace SctCalibrationController {
  /// Allows a ISInfo object to be serialised with the usual SCT serialisation tools.
class IsInfoWrapper : public Sct::Serializable {
 public:
  IsInfoWrapper(boost::shared_ptr<ISInfo> info);
  /// get wrapped (ISInfo) object
  boost::shared_ptr<ISInfo> getWrapped();
  /// (const) get wrapped (ISInfo) object
  boost::shared_ptr<const ISInfo> getWrapped() const;
  /// publish the wrapped object to an IS server
  void publishWrappedObject(const string& isServerName) const;
  /// Destructor
  virtual ~IsInfoWrapper();
 private:
  boost::shared_ptr<ISInfo> wrapped;
};

}

#endif
