#include "SequenceDataWrapper.h"
#include "Sct/LogicErrors.h"
#include "CalibrationController/IS/SequenceData.h"

namespace SctCalibrationController {
  std::string SequenceDataWrapper::getClassName() const{
    return "SequenceData";
  }

  Sct::UniqueID SequenceDataWrapper::getUniqueID() const {
    shared_ptr<const SequenceData> wrapped = boost::dynamic_pointer_cast<const SequenceData>(getWrapped());
    if (!wrapped.get()) throw Sct::IllegalStateError("No wrapped object or bad cast",__FILE__,__LINE__);
    return Sct::UniqueID(wrapped->runNumber, wrapped->startScanNumber, wrapped->sequenceName);
  }

  SequenceDataWrapper::SequenceDataWrapper(boost::shared_ptr<SequenceData> td) : IsInfoWrapper(td) {
  }	
}
