#ifndef SCT_CALIBRATION_CONTROLER_SEQUENCEDATA_WRAPPER_H
#define SCT_CALIBRATION_CONTROLER_SEQUENCEDATA_WRAPPER_H
#include "IsInfoWrapper.h"
#include <boost/shared_ptr.hpp>

class SequenceData;

namespace SctCalibrationController {
  /// Allows a SequenceData object to be serialised with the usual SCT serialisation tools.
class SequenceDataWrapper : public IsInfoWrapper {
 public:
  SequenceDataWrapper(boost::shared_ptr<SequenceData> td);
  /// For backwards-compatibility, returns the name of the _wrapped object_ NOT the wrapper.
  std::string getClassName() const;
  /// Return a normal UniqueID
  Sct::UniqueID getUniqueID() const;
};

}

#endif
