#include "ScanRequest.h"
#include "CalibrationController.h"
#include "RequestException.h"
#include "Sct/SctNames.h"
#include "Sct/BugReport.h"

namespace SctCalibrationController {
  namespace Ipc {
    
    MinimalScanRequest::MinimalScanRequest() :
      m_clockByTwo(false),
      m_width(512),  
      m_configureModules(true) {
    };
    
    CORBA::Boolean MinimalScanRequest::clockByTwoNice() {
      return m_clockByTwo;
    }
    
    CORBA::Long MinimalScanRequest::widthNice() {
      return m_width;
    }
    
    void MinimalScanRequest::setWidthNice(CORBA::Long value) {
      m_width=value;
    }
    
    void MinimalScanRequest::setClockByTwoNice(CORBA::Boolean value) {
      m_clockByTwo=value;
    }
    
    CORBA::Boolean MinimalScanRequest::configureModulesNice(){
      return m_configureModules;
    }

    void MinimalScanRequest::setConfigureModulesNice(CORBA::Boolean val){
      m_configureModules=val;
    }
    
    CORBA::Long MinimalScanRequest::delayNice(){
      return 1;
    }
    
    Sct_SctApi::Scan_ptr MinimalScanRequest::getScanNice(){
      //m_scan->incRef();
      return Sct_SctApi::Scan::_duplicate(m_scan);
    }
    
    void MinimalScanRequest::setScanNice(Sct_SctApi::Scan_ptr scan){
      m_scan=Sct_SctApi::Scan::_duplicate(scan);
    }
    
    CORBA::Boolean MinimalScanRequest::isRawNice(){
      return false;
    }



  ////////////////////////////////////
    
    ScanRequestImpl::ScanRequestImpl() : IPCObject<POA_Sct_CalibrationController::ScanRequest>() {
    }

    
    CORBA::Boolean ScanRequestImpl::isRawCorba() {
      return isRawNice();
    }

    CORBA::Boolean ScanRequestImpl::clockByTwoCorba() {
      return clockByTwoNice();
    }
    
    
    CORBA::Long ScanRequestImpl::widthCorba() {
      return widthNice();
    }

    void ScanRequestImpl::setWidthCorba(CORBA::Long value) {
      setWidthNice(value);
    }
    
    void ScanRequestImpl::setClockByTwoCorba(CORBA::Boolean value) {
      setClockByTwoNice(value);
    }
    
    CORBA::Boolean ScanRequestImpl::configureModulesCorba(){
      return configureModulesNice();
    }

    void ScanRequestImpl::setConfigureModulesCorba(CORBA::Boolean val){
      setConfigureModulesNice(val);
    }
    
    CORBA::Long ScanRequestImpl::delayCorba(
                              ){
      return delayNice();
    }
    
    Sct_SctApi::Scan_ptr ScanRequestImpl::getScanCorba(
){
      return getScanNice();
    }
    
    void ScanRequestImpl::setScanCorba(Sct_SctApi::Scan_ptr scan){
      Sct::BugReport("BUG01", "ScanRequest.cpp","Will this infinite recurse?  It must not! Sleeping 1 sec",1000000);
      setScanNice(scan);
    }
  }
}
