#ifndef NMASKSCAN_H
#define NMASKSCAN_H

#include "../ipc/CalibrationController.hh"
#include "../CalibrationControllerImpl.h"
#include "../SctApiAccessException.h"
#include "../SctApiCall.h"
#include "Sct/LogicErrors.h"

#include <Sct/AbcdScans.h>

using namespace Sct;
using namespace SctCalibrationController::Ipc;
namespace SctCalibrationController {
namespace Scripts {

  /** ask modules to return contents of mask register (i.e. return events of known format) */
    
class NMaskScan : public ScanRequestImpl {
public:
  static ScanRequestImpl& nmaskScan(unsigned long nTrigs) {
    static NMaskScan request;
    Sct_SctApi::SctApiIPC_var api = CalibrationControllerImpl::instance()->getApi();
    Sct_SctApi::Scan_var s;
    APIRETCALL(api, s, createScan(), "Failed to create scan")
    request.setScanNice(s);
    
    APICALL(s, setNTrigs(nTrigs), "Failed to set triggers")
    
    Sct_SctApi::Trigger_var t;
    APIRETCALL(s, t, getTrigger1(), "Failed to get Trigger1")

    APICALL(t, singleL1A(), "Failed to set trigger type")

    APICALL(s, configure(ST_NMASK, 0, 128, 1), "Failed to set Scan information")
    return request;
    }
    
private:
  NMaskScan(){;}
};
    
}
}

#endif //NMASKSCAN_H
