#ifndef TOKENSCAN_H
#define TOKENSCAN_H

#include "../ipc/CalibrationController.hh"

#include "../SctApiAccessException.h"
#include "Sct/LogicErrors.h"

#include <Sct/AbcdScans.h>

using namespace Sct;
using SctCalibrationController::Ipc::ScanRequest;
namespace SctCalibrationController {
namespace Scripts {
    
class TokenScan : public ScanRequestImpl {
public:
    static ScanRequestImpl& tokenScan() {
        static TokenScan request;
	Sct_SctApi::SctApiIPC_var api = CalibrationControllerImpl::instance()->getApi();
        Sct_SctApi::Scan_var s = 0;
        APIRETCALL(api, s, createScan(), "Failed to create scan")
        request.setScanNice(s);

        APICALL(s, setNTrigs(100), "Failed to set triggers")

        Sct_SctApi::Trigger_var t = 0;
        APIRETCALL(s, t, getTrigger1(), "Failed to get Trigger1")

        APICALL(t, singleL1A(), "Failed to set trigger type")

        APICALL(s, configure(ST_TOKEN, 0, 35, 1), "Failed to set Scan information")

        return request;
    }
    
private:
    TokenScan(){;}
};
    
}
}

#endif //TOKENSCAN_H
