/************************************************************************************
 * convertParams.h
 *
 *   Typedefs the version specific input & output structures into the default ones.
 ************************************************************************************/
#ifndef CONVERT_PARAMS
#define CONVERT_PARAMS

#include "primParams.h"
#if   defined(SCT_ROD)
	#include "convertParams_sct.h"
#elif defined(PIXEL_ROD)
	#include "convertParams_pxl.h"
#endif

typedef struct SET_ERRMSG_MASK_IN      SetMessageMaskIn;
typedef struct EVENT_TRAP_SETUP_IN     EventTrapSetupIn;
typedef struct EVENT_TRAP_SETUP_OUT    EventTrapSetupOut;
typedef struct SET_MEMORY_IN           SetMemoryIn;
typedef struct COPY_MEMORY_IN          CopyMemoryIn;
typedef struct MEMORY_TEST_IN          MemoryTestIn;
typedef struct MEMORY_TEST_OUT         MemoryTestOut;
typedef struct SET_LED_IN              SetLedIn;
typedef struct FLASH_LED_IN            FlashLedIn;
typedef struct SEND_DATA_IN            SendDataIn;
typedef struct SEND_DATA_OUT           SendDataOut;
typedef struct MODULE_MASK_IN          ModuleMaskIn;
typedef struct SET_TRIGGER_IN          SetTriggerIn;

typedef struct HISTOGRAM_CTRL_TASK_IN  HistoCtrlTaskIn;
typedef struct HISTOGRAM_CTRL_TASK_OUT HistoCtrlTaskOut;
typedef struct MIRROR_TASK_IN          MirrorTaskIn;
typedef struct TRAP_REQ_TASK_IN        TrapReqTaskIn;

typedef struct HISTOGRAM_TASK_IN       HistogramTaskIn;
typedef struct HISTOGRAM_TASK_OUT      HistogramTaskOut;
typedef struct TRAP_TASK_IN            TrapTaskIn;
typedef struct TRAP_TASK_OUT           TrapTaskOut;
typedef struct OCCUPANCY_TASK_IN       OccupancyTaskIn;
typedef struct ERROR_TASK_IN           ErrorTaskIn;
typedef struct ERROR_INFO              ErrorInfo;
typedef struct ERROR_TASK_OUT          ErrorTaskOut; //TNV
//typedef struct RESYNCH_TASK_IN         ErrorTaskOut; //TNV commented and put the line below
typedef struct RESYNCH_TASK_IN         ResynchTaskIn;
typedef struct GEN_TASK_OUT            GenTaskOut;


typedef union TASK_STRUCTURES_OUT      TaskOutput;
typedef union TASK_STRUCTURES_IN       TaskInput;

typedef struct START_TASK_IN           StartTaskIn;
typedef struct TASK_OPERATION_IN       TaskOperationIn;
typedef struct WRITE_BUFFER_IN         WriteBufferIn;

typedef struct RW_SLAVE_MEMORY_IN     RwSlaveMemory;
typedef RwSlaveMemory                 RwSlaveMemoryIn;
typedef RwSlaveMemory                 RwSlaveMemoryOut;

typedef struct TRANS_DATA             TransData;
typedef struct TRANS_SERIAL_DATA_IN   TransSerialDataIn;
typedef struct START_SLAVE_EXECUTING_IN  StartSlaveExecutingIn;
typedef struct START_SLAVE_EXECUTING_OUT StartSlaveExecutingOut;
typedef struct CONFIG_SLAVE_IN        ConfigSlaveIn;
typedef struct RW_REG_FIELD_IN        RwRegFieldIn;
typedef struct RW_REG_FIELD_OUT       RwRegFieldOut;
typedef struct POLL_REG_FIELD_IN      PollRegFieldIn;
typedef struct POLL_REG_FIELD_OUT     PollRegFieldOut;
typedef struct RW_FIFO_IN             RwFifoIn;
typedef struct RW_FIFO_OUT            RwFifoOut;
typedef struct SEND_SLAVE_LIST_IN     SendSlaveListIn;
typedef struct START_SLAVE_LIST_IN    StartSlaveListIn;
typedef struct SLAVE_LIST_OP_IN       SlaveListOpIn;
typedef struct BUILD_STREAM_IN        BuildStreamIn;
typedef struct SEND_STREAM_IN         SendStreamIn;
typedef struct DSP_RESET_IN           DspResetIn;
typedef struct SET_ROD_MODE_IN        SetRodModeIn;
typedef struct RW_BOC_DATA_IN         RwBocDataIn;
typedef struct RW_BOC_DATA_OUT        RwBocDataOut;
typedef struct BOC_HISTOGRAM_IN       BocHistogramIn;
typedef struct BOC_HISTOGRAM_OUT      BocHistogramOut;

#endif  /* Multiple inclusion protection */
