/* _CLK_REGS and _CLK_USETIMER must be defined here (LT 7/13/01) */
_CLK_REGS = 0;
_CLK_USETIMER = 0;       

/* The MEMORY section lengths defined here MUST agree with the lengths defined
   in memoryPartitions.h! */
MEMORY  {

	VECTORS  : origin = 0x00000000, len = 0x200
	
	IPRAM    : origin = 0x200,        len = 0xfe00

	IDREGS   : origin = 0x80000000, len = 0x80
	IDATA    : origin = 0x80000080, len = 0x800
	IDRAM    : origin = 0x80000880, len = 0x7780
	BURST    : origin = 0x80008000, len = 0x8000
	CMD_BFR  : origin = 0x02102000, len = 0x8000
	STAGE_BFR  : origin = 0x0210a000, len = 0x30000

	/* The program's Flash ROM size (excluding the automatically loaded IPRAM): */
	FLASH      : origin = 0x01410000, len = 0x70000
	
	XPROG      : origin = 0x02000000, len = 0x40000
	XTEXT	   : origin = 0x02040000, len = 0x20000
	XDATA	   : origin = 0x02200000, len = 0x1ff000
	BOCDATA    : origin = 0x023ff000, len = 0x1000
	MODULEDATA : origin = 0x02400000, len = 0xb00000
	HEAP       : origin = 0x02f00000, len = 0x100000
 }  

SECTIONS {
	.vectors 	> VECTORS
	.text 		> IPRAM   /* catchall for program code */

	.usect00  "icode" 		> IPRAM
	.usect02  "xcode" 		> XPROG
	.usect03  "xpdata" 		> XPROG

	.usect04a "csl_ip" 		> IPRAM
	.usect04b "csl_xp" 		> XPROG
	
	.usect05a "rts_ip" 		> IPRAM
	.usect05b "rts_math" 	> IPRAM
	.usect05c "rts_stdio" 	> XPROG

	.usect06  "commRegs" 	> IDREGS
	.usect07  "idata" 		> IDATA
	.usect08  "burst" 		> BURST
	.usect09  "cmdBfr" 		> CMD_BFR
	.usect10  "stageBfr" 	> STAGE_BFR

	.usect11  "bocData" 	> BOCDATA
	.usect12  "moduleData" 	> MODULEDATA
	.usect13  "heap" 		> HEAP
	
	.usect14  "xdata" 		> XDATA
	
   	.cinit 		> FLASH	  
   	.const 		> IDRAM	  
	
   	.data 		> IDRAM
	.switch 	> IDRAM
	.pinit 		> IDRAM
	.cio 		> IDRAM
	.far 		> IDRAM
	.bss 		> IDRAM
	.stack 		> IDRAM	 
	.sysmem 	> IDRAM
}
