#ifndef SIMEVTS_H
#define SIMEVTS_H

#define N_INMEM_EVTS 10

/* bit positions in the 8-bit wide TIM FIFO */
#define L1A_BIT   5
#define ID_BIT    1
#define TYPE_BIT  0

#if   defined(SCT_ROD)
	#include "sctStructure.h"
	#include "ABCDScans.h"

	#define  NCHIPS    16
	#define  NCHAN     N_SCT_CHANS
	#define  NMODULES  N_SCT_MODULES

	#include "simEvts_sct.h"
	#include "inmemFxn_sct.h"

#elif defined(PIXEL_ROD)
	#include "pixelScans.h"
	#include "simEvts_pxl.h"
	#include "inmemFxn_pxl.h"
#endif

#endif /* Multiple inclusion protection */
