
#ifndef LESTER_COUNTEDEXAMPLE_H
#define LESTER_COUNTEDEXAMPLE_H

#include "Rabbit.hh"

#include <ipc/object.h>
#include <iostream>
#include "Sct/RefCountServantBase.h"

class CountedExample : 
  public IPCObject<POA_Stew::CountedExample, // for IPCObjectBase::_destroy()
                   ipc::single_thread>, // vital is single thread for serialisation
  private Sct::RefCountServantBase 
{
  
public:
  CountedExample() {
    std::cout << "Constructing a CountedExample ... " << std::endl;
    // our count starts at one.
  };

 public:
  virtual ~CountedExample() {
    std::cout << "~CountedExample()" << std::endl;
  };

  void addRef() {
    std::cout << "CountedExample::addCount" << std::endl;
    this->_sct_add_ref();
  };

  void removeRef() {
    std::cout << "CountedExample::removeCount" << std::endl;
    this->_sct_remove_ref();

    // when the count gets to zero, 
    // this->performCountEqualsZeroAction() gets called
  };

  void performCountEqualsZeroAction() {
    std::cout << "Moo .. count has reached zero! I think I will commit suicide!" << std::endl;
    this->_destroy();
  };

};

#endif 
