//$Id: SCTScheduledUserAction.cpp,v 1.2 2005/09/21 15:17:52 sctroddq Exp $
/************************************************************************/
/*									*/
/* File             : SCTScheduledUserAction.cpp			*/
/*									*/
/* Authors          : G. Crone, J.Petersen 				*/
/*									*/
/********* C 2004 - ROS/RCD *********************************************/

#include <iomanip>
#include "RCDExampleModules/SCTScheduledUserAction.h"
#include "RCDExampleModules/RCDModulesException.h"
#include "DFDebug/DFDebug.h"
#include "DFError/DFOutputStream.h"
#include <stdlib.h>

using namespace RCD;
using namespace ROS;

/******************************************************************************************************/
SCTScheduledUserAction::SCTScheduledUserAction(int deltaTimeMs) : ScheduledUserAction(deltaTimeMs)
/******************************************************************************************************/
{ 
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::constructor: Entered");

  m_deltaTimeMs = deltaTimeMs;
  srand (1234567);
  m_numberOfTimes = 0;
  
}

/*******************************************************/
SCTScheduledUserAction::~SCTScheduledUserAction() 
/*******************************************************/
{
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::destructor: Entered");
}

/********************************************************************************************************/
void SCTScheduledUserAction::reactTo(void)
/********************************************************************************************************/
{
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::reactTo entered");
  
  int alea = rand();
  
  if (alea < RAND_MAX / 4) {
    std::cout << "reactTo() method::number " << m_numberOfTimes << std::endl;
    m_numberOfTimes++;
  }  

  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::reactTo done");
}

/********************************************************************************************************/
void SCTScheduledUserAction::clearInfo(void)
/********************************************************************************************************/
{
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::clearInfo entered");

}

/*********************************************************/
 void SCTScheduledUserAction::startTrigger(void)
/*********************************************************/
{
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::startTrigger entered");

  m_stopTriggerFlag = false;

}

/*********************************************************/
 void SCTScheduledUserAction::stopTrigger(void)
/*********************************************************/
{
  DEBUG_TEXT(DFDB_RCDEXAMPLE, 15, "SCTScheduledUserAction::stopTrigger entered");

  m_stopTriggerFlag = true;

}
