
#ifndef SCT_REFCOUNTSERVANTBASE_H
#define SCT_REFCOUNTSERVANTBASE_H

//////////////////////////////////////////////////////////////////////
/////////////////////// Sct::RefCountServantBase /////////////////////
//////////////////////////////////////////////////////////////////////

// the idea is that this is a replacement for
// PortableServer::RefCountServantBase
// (see omni-04-02-06/include/omniORB4/poa.h and
// omni-04-02-06/src/lib/omniORB/orbcore/portableserver.cc)
// except that it respects the _destroy() (rather than delete) 
// mechanism requested by ipc::Object.

#include "boost/thread.hpp"

namespace Sct {

  class RefCountServantBase {
  public:
    virtual ~RefCountServantBase();
    
    virtual void _sct_add_ref();
    virtual void _sct_remove_ref();
    virtual void performCountEqualsZeroAction()=0;

  protected:
    inline RefCountServantBase() : pd_refCount(1) {}
    inline RefCountServantBase(const RefCountServantBase&) : pd_refCount(1) {}
    inline RefCountServantBase& operator = (const RefCountServantBase&)
    { return *this; }
    
  private:
    int pd_refCount;
    boost::mutex m_mutex;
  };
  
};

#endif
