#include "NMaskTestResultStreamer_v1.h"
#include "../NMaskTestResult.h"

using namespace Sct;

namespace SctData {
namespace IO {
/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
unsigned NMaskTestResultStreamer_v1::s_version=1;
	
NMaskTestResultStreamer_v1::NMaskTestResultStreamer_v1() throw() {}

bool NMaskTestResultStreamer_v1::inMap = IOManager::addToMap("SctData::NMaskTestResult",  auto_ptr<Streamer>(new NMaskTestResultStreamer_v1()));

shared_ptr<Streamable> NMaskTestResultStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
    shared_ptr<Streamable> ad (new NMaskTestResult());
    read(in, *ad, manager);
    return ad;
}

void NMaskTestResultStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Let superclass do its work
    manager.writeImpl(out, ob, "SctData::TestResult");
}

void NMaskTestResultStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    manager.readImpl(in, ob, "SctData::TestResult");
}

} 
}
