#include "TestApi.h"
#include "Configuration.h"
#include "Sct/Exception.h"

#include "Sct_SctApi/SctApiServer.h"
#include "Sct_SctApi/SctApiCrateServer.h"
#include "sctConfIPC/configipc.h"
#include "SctApi/Idiosyncrasy.h"

#include <ipc/core.h>
#include <ipc/object.h>
#include <ipc/server.h>
#include <pmg/pmg_initSync.h>
#include <Sct/Addressing.h>
#include <Sct/SctNames.h>

#include <iostream>
#include <boost/shared_ptr.hpp>

using namespace std;
using namespace boost;
using namespace SctConfiguration;
using namespace SctTest;

IPCServer ipcServer;
shared_ptr<SctConfiguration::Configuration> configServer;

/*
 Obsolete:
  void pmgSynch(void *) {
    pmg_initSync();
}
*/

int main(int argc, char** argv) {
    Sct::setExceptionHandlers(argv[0]);

    IPCCore::init(argc,argv);
    IPCPartition p(::Sct::SctNames::getPartitionName());
    // Obsolete: ipcServer.reset(new IPCServer(Sct_SctApi_C_SctApi_serverName, p));

    try {
        //For some reason these 2 lines don't work - really strange bug...so use default constructor trick
        //configServer.reset(new ConfigIPC());
        //auto_ptr<TestApi> api(new TestApi(configServer));
	const Sct::UCID arbitraryUcid(0,0);
        SctApi::Idiosyncrasy id(arbitraryUcid);

        auto_ptr<TestApi> api(new TestApi(id));

        if (!SctTest::Configuration::instance().publish()) {
            cout << "Failed to publish Configuration" << endl;
            return 2;
        }

//        if (!HighLevelApi::instance().publish()) {
//            cout << "Failed to publish HighLevelApi" << endl;
//            return 3;
//        }
	
        auto_ptr<SctApiCrateServer> h2(new SctApiCrateServer(*api)); // probably this should be updated to be a "_destroy"ing deleter.
	
	SctApiServer::CrateDescriptors d; d.push_back(arbitraryUcid);
        auto_ptr<SctApiServer> h(new SctApiServer(d, Sct_SctApi::SctApiIPC::instanceName)); // probably this should be updated to be a "_destroy"ing deleter.

        // Try publishing it
        if (!h->publish()) {
            cout << "Failed to publish SctTestApi" << std::endl;
            return 2;
        }

        cout << "Serving...\n";

 	// Obsolete:       ipcServer->doSoon(pmgSynch, NULL);
	pmg_initSync();
	ipcServer.run();

        cout << "Run over" << std::endl;
        h->withdraw();
        SctTest::Configuration::instance().withdraw();
//        HighLevelApi::instance().withdraw();

    } catch(SctConfiguration::ConfigurationException &c) {
        std::cout << "ConfigurationException: " << c.what() << std::endl;

        MRSStream mrsStream(p);
        mrsStream << "SctTestApi" << MRS_FATAL << MRS_QUALIF("SctTestApi") << MRS_TEXT("Configuration server not running!") << ENDM;

        exit(1);
    }
}
