
#include "Idiosyncrasy.h"
#include <sstream>

namespace SctApi {

  Idiosyncrasy::Idiosyncrasy(const Sct::PartitionIdentifier p,
			     const Sct::CrateIdentifier c) :
    m_ucid(Sct::UCID(p,c)) {
  };

  Idiosyncrasy::Idiosyncrasy(const Sct::UCID & ucid) :
    m_ucid(ucid) {
  };

  const Sct::UCID & Idiosyncrasy::ucid() const {
    return m_ucid;
  };

  const std::string & Idiosyncrasy::uniqueName() const {
    if (m_uniqueName == "") {
      std::ostringstream os;
      os << "CrateServer_P"<<ucid().partition() << "_C" << ucid().crate(); // regrettably we can't just do 'os<<"CrateServer"<<m_ucid' as m_ucid has dots in it and you are not advised to put dots into an IS-name.
      m_uniqueName = os.str();
    };
    return m_uniqueName;
  };
  
  const std::string & Idiosyncrasy::infoServiceNameOfScanStatusObject() const {
    if (m_infoServiceNameOfScanStatusObject == "") {
      std::ostringstream os;
      os << "SCTAPIServer.scanning_" << uniqueName();
      m_infoServiceNameOfScanStatusObject = os.str();
    };
    return m_infoServiceNameOfScanStatusObject;
  };

  const std::string & Idiosyncrasy::ipcNameOfSctApiCrateServer() const {
    if (m_ipcNameOfSctApiCrateServer == "") {
      std::ostringstream os;
      os << "IpcObj_" << uniqueName();
      m_ipcNameOfSctApiCrateServer = os.str();
    };
    return m_ipcNameOfSctApiCrateServer;
  };

}; // end of namespace SctApi

