#ifndef SCTAPI_SCANMONITOR_H
#define SCTAPI_SCANMONITOR_H

/* Because this is used in IPC, put in a separate file to the 
   rest of SctApiHisto
*/

namespace SctApi {

class ScanControl;

/**
   High-level scan interface for use over IPC

   For internal scans the job of scan monitor is done by scanLoop and pollHistogramming.
 */
class ScanMonitor {
 public:
  /** Move to another bin and notify of trigger count for current one */
  virtual void newBin(int prevTriggers, int newBin) = 0;

  /** Stop tasks and readout histogram */
  virtual void finishScan() = 0;
};

}
#endif
