#ifndef SCTAPI_SCAN_MONITOR_IMPL_H
#define SCTAPI_SCAN_MONITOR_IMPL_H

#include <boost/shared_ptr.hpp>

#include "ScanMonitor.h"

namespace SctApi {

class ScanMonitorImpl : public ScanMonitor {
 protected:
  boost::shared_ptr<ScanControl> controller;
 public:
  ScanMonitorImpl(boost::shared_ptr<ScanControl> control);

  virtual ~ScanMonitorImpl();

  /** Move to another bin and notify of trigger count for current one */
  void newBin(int prevTriggers, int newBin);

  /** Stop tasks and readout histogram */
  void finishScan();
};

}

#endif
