
#ifndef SCT_SCTAPI_SCTAPIEXCEPTION_H
#define SCT_SCTAPI_SCTAPIEXCEPTION_H


/**
   Exception to be thrown by public API methods
*/

//fwd dec
namespace SctApi {
  class SctApiException;
};

// includes

// other fwddecs
namespace SctApi {
  class CrateException;
};

// defn
namespace SctApi {

  class SctApiException : public std::exception {
    std::string desc;
  public:
    /// Provide a description on construction
    SctApiException(const std::string &str) throw() : desc(str) {}

    /// Copy a crate exception
    SctApiException(const CrateException &c) throw();

    ~SctApiException() throw() {}

    /// Override std::exception method
    virtual const char* what () const throw() { return desc.c_str(); }
  };

};

#endif
