#ifndef TAPI_WRAPPERS_H
#define TAPI_WRAPPERS_H

// Stuff to hide from CINT

#include <boost/shared_ptr.hpp>

namespace SctApi {
  class TriggerImpl;
  class ScanDefImpl;
  class ScanMonitorImpl;
}

class TScanMonitor;

class TriggerWrapper {
 public:
  boost::shared_ptr<SctApi::TriggerImpl> worker;
  boost::shared_ptr<SctApi::Trigger> getTrigger();

  friend class TApi;
  friend class TScanDef;
};

class ScanDefWrapper {
 public:
  boost::shared_ptr<SctApi::ScanDefImpl> worker;
  boost::shared_ptr<SctApi::Scan> getScan();

  friend class TApi;
};

class ScanMonitorWrapper {
 public:
  static TScanMonitor *createMonitor(boost::shared_ptr<SctApi::ScanMonitor> monitor);

  boost::shared_ptr<SctApi::ScanMonitor> worker;
  boost::shared_ptr<SctApi::ScanMonitor> getMonitor();

  friend class TApi;
};

#endif
