#include "SctApiGeneral_Test.h"
#include "../SctApiFwd.h"
#include "../utility.h"
#include <boost/test/unit_test.hpp>

#include "primParams.h"

using boost::unit_test_framework::test_suite;

namespace SctApi {
  namespace Tests {
    void testConfigs() {
#ifdef CONFIG_MODULE_CFG
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_NONE), 0);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_BASIC), CONFIG_MODULE_BASIC);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_TRIM), CONFIG_MODULE_TRIM);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_CFG),  CONFIG_MODULE_CFG);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_ALL),  CONFIG_MODULE_ALL);

      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigTypeBitset(1<<SCTAPI_CONFIG_ALL, true), CONFIG_MODULE_ALL);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigTypeBitset(1<<SCTAPI_CONFIG_BASIC, true), CONFIG_MODULE_BASIC);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigTypeBitset(1<<SCTAPI_CONFIG_CFG, true), CONFIG_MODULE_CFG);

      UINT32 sample_api_bitset = (1<<SCTAPI_CONFIG_BASIC)|(1<<SCTAPI_CONFIG_TRIM);
      UINT32 sample_dsp_bitset = Utility::translateConfigTypeBitset(sample_api_bitset);
      UINT32 sendable_dsp_bitset = Utility::getSetableConfigType(sample_dsp_bitset, true);
      
      BOOST_CHECK_EQUAL(sendable_dsp_bitset, CONFIG_MODULE_ALL);
#else
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_BASIC), MODULE_BASIC);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_TRIM),  MODULE_TRIM);
      BOOST_CHECK_EQUAL(::SctApi::Utility::translateConfigType(SCTAPI_CONFIG_ALL),  MODULE_ALL);
#endif
    }

    
    SctApiGeneral_Test::SctApiGeneral_Test() {
      add(BOOST_TEST_CASE(&testConfigs));
    }
  }
}
