#ifndef SCTAPI_LOG_H
#define SCTAPI_LOG_H

#include <fstream>
#include <string>
#include <boost/thread.hpp>
#include "Sct/Addressing.h"

namespace SctApi {
/**
   A logging class, just an ofstream 
   that opens a fixed file
 */
class Log : public std::ofstream {
 public:
  /// Create file
  Log(const Sct::UCID &);
  /// Create file
  Log(const Sct::UCID &, std::string fname);
  /// Create file
//  Log(std::string fname, int instance);

  /// Make sure file is saved on exit
  ~Log();
  boost::mutex & mutex() { return m_logMutex; };
 private:
  std::string getDefaultFileName() const;
  void printHeader();
  void printTrailer();
  /* **********  Mutexes  ********** */
  boost::mutex m_logMutex;
  const Sct::UCID m_ucid;
};

}

#endif
