#define USELIBRARY

#include <iostream>

#include "../TApi.h"

int main() {

  std::set_terminate(__gnu_cxx::__verbose_terminate_handler);


  TScanDef synch;
  synch.distSlave=0;
  synch.tim=1;
  synch.ope=1;
  synch.nth=15;
  synch.trigSequence.singleL1A();
  synch.configure(41, 0.9, 1.1, 0.05);
  synch.trigsPerBurst = 100;
  synch.debug=1;
  synch.print();

  // Start TApi
  TApi tapi;
  tapi.setDebugOption("save_histogram");
  tapi.initialiseAll(0);
  tapi.setDebugOption("tim_scan_status");

  tapi.modifyABCDVar(11, 1.0);
  tapi.modifyABCDVar(13, 0.0);
  tapi.modifyABCDVar(14, 0.0);     // Send mask bit
  tapi.doScan(synch);

  tapi.awaitScan();

  std::cout << "SYNCH: Scan complete\n";
}
