
#ifndef SCT_APISERVERSTATUSMANAGER_H
#define SCT_APISERVERSTATUSMANAGER_H


//fwd dec:
namespace Sct {
  class ApiServerStatusManager;
};

// fwdDec others;
class ISInfoDictionary;
#include "boost/shared_ptr.hpp"
#include <string>

namespace Sct {

  class ApiServerStatusManager {
  public:
    ApiServerStatusManager(const std::string & infoServiceName);// something to distunguish us from all the other SctApiIPC{Crate,Top}Servers that might be running.  Should take the form SERVER.NAME

    // REMOVE! std::string nameOfGeneralStatusISObject() const;
    std::string nameOfScanningStatusISObject() const;

    /* REMOVE!
    typedef enum GeneralStatus {present=1, initialised=2} GeneralStatusEnum;

    
    void publishGeneralStatusForFirstTime();
    void setGeneralStatusTo(const GeneralStatusEnum i);
    void withdrawGeneralStatus();
    */

    void publishScanningState();
    void withdrawScanningState();

    bool hasFinishedScanning();

  private:
    void refreshCache(); // used to update the status of m_hasFinishedScanning from IS

  private:
    boost::shared_ptr<ISInfoDictionary> m_isDict;
    const std::string m_infoServiceName;
    /*
    const std::string m_uniqueIdentifier;
    std::string m_gsName;
    std::string m_ssName;
    */
    bool m_hasFinishedScanning;
    
  };

};

#endif
