#ifndef SCTAPIIPC_LOCALUTILS_H
#define SCTAPIIPC_LOCALUTILS_H

static Sct_SctApi::SctApiException myRaise( ::SctApi::SctApiException &s);
static inline SctApi::BankType myTranslateBank(Sct_SctApi::BankType bank);
static inline SctApi::RunType myTranslateRun(Sct_SctApi::RunType mode);

Sct_SctApi::SctApiException myRaise( ::SctApi::SctApiException &c) 
{
  cout << "Raising exception " << c.what() << endl;
  return Sct_SctApi::SctApiException(c.what());
}


SctApi::BankType myTranslateBank(Sct_SctApi::BankType bank) {

  SctApi::BankType result;
  switch(bank) {
  case Sct_SctApi::PHYSICS_CONFIG:
    result = ::SctApi::SCTAPI_BANK_PHYSICS;
    break;
  case Sct_SctApi::CALIBRATION_CONFIG:
    result = SctApi::SCTAPI_BANK_CALIBRATION;
    break;
  case Sct_SctApi::SCAN_CONFIG:
    result = SctApi::SCTAPI_BANK_SCAN;
    break;
  default:
    result = SctApi::SCTAPI_BANK_PHYSICS;
    break;
  }
  return result;
}

static inline
std::list<SctApi::BankType> myTranslateBanks(const Sct_SctApi::BankList& banks){
  std::list<SctApi::BankType> copied;
  for (unsigned i=0; i<banks.length(); ++i){
    copied.push_back(myTranslateBank(banks[i]));
  }
  return copied;
}

SctApi::RunType myTranslateRun(Sct_SctApi::RunType mode) {
  SctApi::RunType result;
  switch(mode) {
  case Sct_SctApi::PHYSICS_RUN_TYPE:
    result = ::SctApi::SCTAPI_RUN_PHYSICS;
    break;
  case Sct_SctApi::CALIBRATION_RUN_TYPE:
    result = SctApi::SCTAPI_RUN_CALIBRATION;
    break;
  }
  return result;
}

SctApi::EventFormatType myTranslateEventFormat(Sct_SctApi::EventFormatType format) {
  SctApi::EventFormatType result;
  switch(format) {
  case Sct_SctApi::NORMAL_EVENT_FORMAT:
    result = ::SctApi::SCTAPI_EVENT_FORMAT_NORMAL;
    break;
  case Sct_SctApi::EXPANDED_EVENT_FORMAT:
    result = SctApi::SCTAPI_EVENT_FORMAT_EXPANDED;
    break;
  case Sct_SctApi::RAW_EVENT_FORMAT:
    result = SctApi::SCTAPI_EVENT_FORMAT_RAW;
    break;
  }
  return result;
}

#endif
