#ifndef SCTAPI_SCANMONITORSERVER_H
#define SCTAPI_SCANMONITORSERVER_H

#include <boost/shared_ptr.hpp>
#include <ipc/object.h>
#include "SctApi.hh"

namespace SctApi {
  class ScanMonitor;
}

class ScanMonitorServer : public IPCNamedObject<POA_Sct_SctApi::ScanMonitor> {
  static int nextNumber;

  boost::shared_ptr< ::SctApi::ScanMonitor> m_worker;
  SctApi::ScanMonitor &worker() { return *m_worker; }

  std::string getServerName();
 public:
  ScanMonitorServer(boost::shared_ptr<SctApi::ScanMonitor> mon);
  void newBin(CORBA::ULong prevTriggers, CORBA::UShort newBin);
  void finishScan();
};

#endif


