#ifndef SCTAPIIPC_SCANMONITORWRAPPER_H
#define SCTAPIIPC_SCANMONITORWRAPPER_H

// Actually, ignore this never gets used

/** @class ScanMonitorWrapper ScanMonitorWrapper.h
 *
 * The class ScanMonitorWrapper is designed to look externally like a
 * ::SctApi::ScanMonitor (i.e. implement the ::SctApi::ScanMonitor interface) 
 * while actually just passing all these calls through to a CORBA 
 * trigger object, which is itself internally implemented by a 
 * "standard" SctApi trigger object!
 *
 * This class DOES NOT OWN the object reference which it is 
 * constructed with!  An alternative strategy could be developed ...
 *
 * @author Christopher Lester
 **/

// Need complete types for public inheritence
#include "SctApi/ScanMonitor.h" 
#include "Sct_SctApi/SctApi.hh" // for ScanMonitor{_var,_ptr} interface 

class ScanMonitorWrapper : public ::SctApi::ScanMonitor {
 public:
  typedef enum MemoryPolicy_enum { 
    takeOwnershipOfObjectReference, 
    doNotTakeOwnershipOfObjectReference
  } MemoryPolicy;
 private:
  const MemoryPolicy m_memoryPolicy;
  typedef Sct_SctApi::ScanMonitor_ptr WorkerType;
  WorkerType m_worker;
  const WorkerType worker() const { return m_worker; };
  WorkerType worker() { return m_worker; };
 public:
  ScanMonitorWrapper(const WorkerType & w, const MemoryPolicy memoryPolicy) :
    m_memoryPolicy(memoryPolicy),
    m_worker(w) {
  };
  virtual ~ScanMonitorWrapper() {
    if (m_memoryPolicy==takeOwnershipOfObjectReference) {
      CORBA::release(m_worker);
    };
  };

  // This would be useful...
  char *status();
};

#endif
