
#include "TriggerWrapper.h"
#include "RODTriggerTranslation.h"
#include "Sct/OmniMarshalling.h"

const TriggerWrapper::RODTriggers TriggerWrapper::getRODTriggers(int point) const {
  Sct_SctApi::RODTriggers * rTrigs = worker()->getRODTriggers(point);
  const TriggerWrapper::RODTriggers ans = copyCorbaToRODTriggers(rTrigs);
  delete rTrigs;
  return ans;
}; 

const TriggerWrapper::TIMTriggers TriggerWrapper::getTIMTriggers(int point) const {
  Sct_SctApi::TIMTriggers * tTrigs = worker()->getTIMTriggers(point);
  const TriggerWrapper::TIMTriggers ans = 
    Sct::copyCorbaToStdCollection<Sct_SctApi::TIMTriggers,::SctApi::Trigger::TIMTriggers>(tTrigs);
  delete tTrigs;
  return ans;
}

std::string TriggerWrapper::print() const{
  CORBA::String_var output=worker()->print();
  std::string output_as_string;
  output_as_string=output;
  return output_as_string; 
}
