#include <boost/date_time/posix_time/posix_time.hpp>
#include "SctApiSource_Test.h"
#include "../SctApiServer.h"
#include "SctApi/SctApi.h"
#include "SctApi/Trigger.h"
#include <boost/test/unit_test.hpp>
#include <iostream>

using boost::unit_test_framework::test_suite;
using namespace boost::posix_time;
using namespace boost::gregorian;

namespace SctApi {
  namespace Tests {
    void testSources() {
	BOOST_CHECK((int)::Sct_SctApi::Trigger::SOURCE_UNKNOWN == 
		    (int)::SctApi::Trigger::SOURCE_UNKNOWN); 
        BOOST_CHECK((int)::Sct_SctApi::Trigger::SOURCE_ROD == 
		    (int)::SctApi::Trigger::SOURCE_ROD);
        BOOST_CHECK((int)::Sct_SctApi::Trigger::SOURCE_TIM_INTERNAL == 
		    (int)::SctApi::Trigger::SOURCE_TIM_INTERNAL);
        BOOST_CHECK((int)::Sct_SctApi::Trigger::SOURCE_TIM_EXTERNAL == 
		    (int)::SctApi::Trigger::SOURCE_TIM_EXTERNAL);
    }
  
    
    SctApiSource_Test::SctApiSource_Test() {
      add(BOOST_TEST_CASE(&testSources));
    }	
  }
}
