#ifndef SCTCONFIGURATIONRUNCONTROLLER_H
#define SCTCONFIGURATIONRUNCONTROLLER_H

#ifdef linux
#undef linux
#endif

#include <rc/UserRoutines.h>
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>
#include <string>
#include "sctConf/configuration.h"
#include "Sct/ConfigurationException.h"
#include "Sct_SctApi/SctApi.hh"

using std::string;

namespace SctConfigurationController {

  /** run controller for the config server */
class RunControl : public RC::UserRoutines, boost::noncopyable {
public:
  
  static RunControl& initialize(SctConfiguration::Configuration& c);
  virtual bool prepareAction();
  virtual bool stopEFAction();
  virtual bool loadAction();
  virtual ~RunControl();
 private:
  /// internal method requests save with filename suffix
  void doSave(const std::string& suffix);
  RunControl(SctConfiguration::Configuration& c);
  RunControl();
  Sct_SctApi::SctApiIPC_var getApi();
  SctConfiguration::Configuration* config;
};

}

#endif //SCTCONFIGURATIONRUNCONTROLLER_H
