#include <TApplication.h>

#include "DataDisplayerMainRootHelper.h"
#include "DisplayManager.h"

/* 
   Very strange symptom:
    Apparently if TString.h gets included (gets included by TApplication) then 
    the ofstream constructor fails with -O3 (the overloading of (char* + int) 
    confuses the compiler).

    I'm not sure whether this is ROOT's fault or the compiler's... though would 
    certainly help if the TString stuff was in a different namespace.

   Solution:
    Put access to TApplication in a separate file (this one)
 */

using namespace SctDataDisplay;

namespace SctDataDisplayHelper {
  TApplication* myapp=0;

  void createApp(bool batch) {
    //Create TApplication - necessary to prevent batch mode and no graphics on later ROOT versions
    if (!batch) myapp=new TApplication("myapp", 0, 0);
  }

  void runCanvas() {
    if (myapp) { 
      myapp->Run();
    } else {
      DisplayManager::OutputCanvases();
    }
  }
}
