#include "ObserverInterface.hh"
#include "ipc/core.h"
#include "ipc/object.h"
#include "ipc/partition.h"
#include "Sct/Exception.h"
#include "Sct/SctNames.h"
#include <iostream>
#include <memory>

using namespace std;
using namespace Sct;

int main(int argc, char**argv){
    setExceptionHandlers(argv[0]);
    IPCCore::init(argc, argv);
    
    auto_ptr<IPCPartition> p (new IPCPartition(::Sct::SctNames::getPartitionName()) );
    
    cout <<" ... getting a handle ..."<<endl;
    Observer::ObserverInterface_var handle = p->lookup<Observer::ObserverInterface>("TestListener");

    if (CORBA::is_nil(handle)){ cerr<<"Error: handle is nil"<<endl; return -1;}
    
    if (argc==1){
      int i=1;
      
      while (i>0) {
	cout << "enter data (integers) terminated by 0, or -1 to stop"<<endl;
	cin >> i;
	handle->ipcAdd(i);
	cout << "busy=" << handle->ipcBusy() <<endl;
      }
      if (i==-1) handle->ipcStop();
    }
    cout << "nWorkers = " << handle->ipcNWorkers() <<endl;
    cout << "busy     = " << handle->ipcBusy() <<endl;
    cout << "Queue    = " << handle->ipcQueueSize() <<endl;
}
