// For gcc296 floor
#include <cmath>

#include "SummaryManager.h"
#include "DoubleTriggerNoiseSummaryWriter.h"
#include "SctData/DoubleTriggerNoiseTestResult.h"

namespace SctData { 
    namespace TestSummary{
	using namespace std;

	void DoubleTriggerNoiseSummaryWriter::write(const TestResult& t, ostream& out) const throw(Sct::IoError, Sct::LogicError)
	{
	    const DoubleTriggerNoiseTestResult& result  = dynamic_cast<const DoubleTriggerNoiseTestResult&>(t);

	    out << "#\n%DoubleTriggerNoise\n#\n#Average\tPeak\tPeakRatio\tPeakBin\n";
	    for (unsigned ichip=0; ichip<nChipModule; ++ichip){
	      out << "#" << getChipName(ichip) << endl
		  << result.getPedestalOccupancy(ichip) << "\t"
		  << result.getPeakOccupancy(ichip) << "\t"
		  << result.getPeakRatio(ichip) << "\t"
		  << result.getPeakOccupancyBin(ichip)  << endl;
	    }
	    SummaryWriter::write(result.getDefects(), out);
	    
	}
	
	bool DoubleTriggerNoiseSummaryWriter::inMap = SummaryManager::instance().addWriter("SctData::DoubleTriggerNoiseTestResult", shared_ptr<SummaryWriter>(new DoubleTriggerNoiseSummaryWriter()));
    }
}
