#!/bin/sh

#The oracle name space file
export TNS_ADMIN=/afs/cern.ch/project/oracle/admin

# A couple of locations of COOL dependencies
# For COOL_1_2_0 dependencies see: http://lcgapp.cern.ch/project/spi/lcgsoft/COOL_1_2_0_slc3_ia32_gcc323-download.html

# here I'm only going to set the main dependencies: COOL, POOL and SEAL
#general location...to avoid writting the same sentence multiple times
export LCG_HOME=/afs/cern.ch/sw/lcg/app/releases

export POOL_HOME=${LCG_HOME}/POOL/POOL_2_1_2/slc3_ia32_gcc323
export SEAL_HOME=${LCG_HOME}/SEAL/SEAL_1_7_1/slc3_ia32_gcc323
export COOL_HOME=${LCG_HOME}/COOL/COOL_1_2_3/slc3_ia32_gcc323



### Now let's get to the real work.
### the libraries of all depenencies must be refered in LD_LIBRARY_PATH
#if [ -z "$LD_LIBRARY_PATH" ]; then
#    export LD_LIBRARY_PATH
#fi

#if you are not in lxplus this is extremely important
export LD_LIBRARY_PATH=${SEAL_HOME}/lib:${POOL_HOME}/lib:${COOL_HOME}/lib:${LD_LIBRARY_PATH}

# Not mandatory, but allows to control the verbosity of SEAL and friends
#export SEAL_CONFIGURATION_FILE=./seal.opts

#mandatory and cdi complains if not set
export SEAL_KEEP_MODULES=true

export SEAL_PLUGINS=${SEAL_HOME}/lib/modules
export SEAL_PLUGINS=${SEAL_PLUGINS}:${POOL_HOME}/lib/modules
export SEAL_PLUGINS=${SEAL_PLUGINS}:${COOL_HOME}/lib/modules

#### Teh database connection profiles...here we have a full set of them
#export TDAQ_COOL_PROFILE="mysql://pcatlas211.cern.ch;schema=cdi_ONLCOOL;user=cdiuser;password=pwd4cdi;dbname=CDI_NB"
export TDAQ_COOL_PROFILE="oracle://devdb10;schema=ATLAS_NFIUZA;user=atlas_nfiuza;password=tripas;dbname=TEST_SCT"
export TDAQ_COND_DB_PROFILE="atlobk02.cern.ch:test_sct_v2:conditions:conditions:3306"

# Just in case you want to use COOL with MySQL this also needs to be used
export ODBCSYSINI=/afs/cern.ch/sw/lcg/external/unixodbc/2.2.6/slc3_ia32_gcc323/etc
export LD_LIBRARY_PATH=/afs/cern.ch/sw/lcg/external/myodbc/3.51.06_mysql.4.0.18/slc3_ia32_gcc323/lib:${LD_LIBRARY_PATH}

## There has been a failure concerning the oracle locations...
##let's fix it here
export LD_LIBRARY_PATH=/afs/cern.ch/sw/lcg/external/oracle/10.1.0.3-1/slc3_ia32_gcc323/lib:${LD_LIBRARY_PATH}

#define the location of tthe boost regex library as needed in the latest version of the CDI
export LD_LIBRARY_PATH=/afs/cern.ch/sw/lcg/external/Boost/1.32.0/slc3_ia32_gcc323/lib:${LD_LIBRARY_PATH}
