
##################################################
#                                                #
# ATLAS SCT Environment Setup:   SR1 DAQ System  #
#                                                #
#                                                #
##################################################

###############################
#Required variables for running
###############################


###### External Software ######
#
export CMTCONFIG=i686-slc3-gcc323-opt
#export CMTCONFIG=i686-rh73-gcc32-opt

# Initialise the online software
source /home/sctroddq/sctsw/tdaq-01-02-00/installed/setup.sh
export PATH=${TDAQ_JAVA_HOME}/bin:${PATH}
export PYTHONPATH=${TDAQ_INST_PATH}/${CMTCONFIG}/lib


# Setup the DataFlow software
#export DF_INST_PATH=/home/sctroddq/sctsw/DF-01-00-00/installed
#export PATH=${DF_INST_PATH}/${CMTCONFIG}/bin:${DF_INST_PATH}/share/bin:${PATH}
#export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${DF_INST_PATH}/${CMTCONFIG}/lib

# Setup the PVSS libraries - may not be necessary
# export PVSS_PATH=/sct1/dcssoft/dcssoft/pvss2_v3.0
# export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${PVSS_PATH}/bin
# export PATH=${PATH}:${PVSS_PATH}/bin

#Setup ROOT - now in .bashrc
#export ROOTSYS=/usr/local/shared/root
#export PATH=${ROOTSYS}/bin:${PATH}
#export LD_LIBRARY_PATH=${ROOTSYS}/lib:${LD_LIBRARY_PATH}

#
export LD_LIBRARY_PATH=/usr/lib:${LD_LIBRARY_PATH}


######## Our Software #########

# The following should set SCT_DAQ_ROOT to the directory this script is run from
export SCT_DAQ_ROOT=/home/sctroddq/sctsw/SctRodDaq

# Set this to your rod configuration:  TestRod.xml for no real ROD hardware
#export SCTDAQ_ROD_CONFIGURATION_PATH=/home/sctroddq/sctsw/configs/barrel_sector2/new_sector.xml
export SCTDAQ_ROD_CONFIGURATION_PATH=/home/sctroddq/sctsw/configs/Barrel5/Barrel5.xml

# Set the Online partition:  SCT_test.xml | SCT.xml | SCT_nodcs.xml
export TDAQ_DB_DATA=${SCT_DAQ_ROOT}/installed/config/databases/SCT_nodcs.data.xml
#export TDAQ_DB_DATA=${SCT_DAQ_ROOT}/installed/config/databases/SCT.data.xml

#Only necessary if you share your online software installation
#export TDAQ_IPC_INIT_REF=file:${SCT_DAQ_ROOT}/ipc.ref.file

# Directory to put IS proxy files
export SCT_SCRATCH_DIR=/work/pcphsctr04/tmp

# Directory to permanently save data
export SCT_PERSISTENT_DIR=/work/pcphsctr04/saved_data

# Hostname-qualified directory to permanently save data
export SCT_PERSISTENT_FQDN_DIR=`hostname --fqdn`:${SCT_PERSISTENT_DIR}




################################
#Required variables for building
################################

# Point to external programs
export BOOSTDIR=/home/sctroddq/sctsw/boost-1.30.2

### Only if NAG is installed.  Ignored otherwise.
export NAGDIR=/home/sctroddq/sctsw/Nag_C


# Point to external java jar files
export SCT_DAQ_EXT=/home/sctroddq/sctsw/ext

export CLASSPATH=${CLASSPATH}:/home/sctroddq/sctsw/ext/junit.jar

###export SCTPIXEL_DAQ_ROOT=/sct1/daqsoft/sctpixel/RodDaq
export SCTPIXEL_DAQ_ROOT=/home/sctroddq/sctsw/RodDaq

########access afs
#/usr/sue/bin/klog sctroddq -pipe < $HOME/.p
#####################################
#And finally, source the setup script
#####################################

## The change of directory isn't in exampleSetup.sh ##
cd ${SCT_DAQ_ROOT}
source ./setup.sh
