/*
 * ConfigurationListener.java
 *
 * 
 */

package DisplayGUI;

import Sct.IS.SctNames;
import is.*;
import CS.RCStateInfo; // Warning! This file is not always included in the tdaq source release, being gnereated from xml source.  You may need to do something like: cp /afs/cern.ch/atlas/project/tdaq/cmt/tdaq-01-04-00-or-other-version-number/ClipsServer/jsrc/* $TDAQ_INST_PATH/../ClipsServer/jsrc The relevant file for this package is RCStateInfo.java
//import CS.DAQApplicationInfo; // ditto as above, except the relevant file is DAQApplicationInfo.java


public class ConfigurationListener implements InfoListener {
    
    gui guiControl;
    String rc_status="NONE";

    public ConfigurationListener(gui parent) {
        guiControl=parent;
        subscribe();
    }

    private void subscribe() {     


 //       try {
 //          is.subscribe("ConfigurationServer","ModuleConfChangeCount",false,this);
 //          is.subscribe("ConfigurationServer","ModuleMappingChangeCount",false,this);
 //          is.subscribe("ConfigurationServer","SystemStructureChangeCount",false,this);
 //       } catch (RuntimeException e2) {
 //           System.err.println("SctGUI::ConfigurationListener::Couldn't subscribe to ConfigurationServer: " + e2.toString());
 //       }
        try {
          GuiComponents.System.ISInterface.getInstance().subscribe("RunCtrl","RootController",false,this);
        } catch (RuntimeException e3) {
            System.err.println("SctGUI::ConfigurationListener::Couldn't subscribe to RunCtrl.RootController: " + e3.toString());
        }
    }
    
    void close() {


        try {
//            is.unsubscribe("ConfigurationServer","ModuleConfChangeCount");
//            is.unsubscribe("ConfigurationServer","ModuleMappingChangeCount");
//            is.unsubscribe("ConfigurationServer","SystemStructureChangeCount");
            GuiComponents.System.ISInterface.getInstance().unsubscribe("RunCtrl","RootController");
        } catch (RuntimeException e2) {
            System.err.println("Couldn't unsubscribe from ConfigurationServer: " + e2.getMessage());
        }
    }

    abstract class StringRunnable implements Runnable {
	protected String name;
	StringRunnable(String name) {
	    this.name = name;
	}
    }

    public void infoCreated(is.InfoEvent infoEvent) {
//       javax.swing.SwingUtilities.invokeLater(new StringRunnable(infoEvent.getName()) {
//          public void run() {
//                  if(!name.equals("RunCtrl.RootCtrl")) resetDisplayConfiguration();
//             }
//        });
        infoUpdated(infoEvent);
    }

    public void infoDeleted(is.InfoEvent infoEvent) {
      infoUpdated(infoEvent);
    }

    public void infoUpdated(is.InfoEvent infoEvent) {
    // run states:
    // NONE <-> INITIAL <-> LOADED <-> CONFIGURED <-> READY <-> RUNNING <-> READY <-> PAUSED
//       System.out.println("*** got "+infoEvent.getName());
       javax.swing.SwingUtilities.invokeLater(new StringRunnable(infoEvent.getName()) {
          public void run() {
	        if(GuiComponents.System.ISInterface.getInstance().getRepository().contains(name)) {
                  RCStateInfo rc = new RCStateInfo();
                  GuiComponents.System.ISInterface.getInstance().getRepository().getValue(name, rc);
//		  System.out.println("new run state = "+rc.state);
		  if(rc.state.matches("CONFIGURED") && rc_status.matches("LOADED")) resetDisplayConfiguration();
		  if(rc.state.matches("INITIAL") && rc_status.matches("NONE")) resetCCPanel();
		  if(rc.state.matches("NONE") && rc_status.matches("INITIAL")) {resetCCPanel();resetDisplayConfiguration();}
		  rc_status=rc.state;
		  }
                else rc_status="NONE";
        //        System.out.println("RC moved to state "+rc_status);

             }
        });
    }


    private void resetCCPanel() {
       GuiComponents.System.SystemInterface.getInstance().refresh();
       GuiComponents.System.ISInterface.getInstance().refresh();
       guiControl.calibrationControllerPanel.subscribeToServers(); // fix for loss of contact
       guiControl.guiMenus.rebuildTestMenus(); // rebuild all tests menu - requires CC to be present
       }
       
    private void resetDisplayConfiguration() {
       GuiComponents.System.SystemInterface.getInstance().refresh();
       GuiComponents.System.ISInterface.getInstance().refresh();
       ConfigurationInterface.getInstance().Refresh();
       guiControl.displayStatus.setConfigurationMode();
       int nmods = ConfigurationInterface.getInstance().getTotalNumberOfModules();
       System.out.println("Configuration updated with "+nmods+" modules.");
       int cacheSize = nmods<200 ? 200 : nmods;
       cacheSize*=2;
       guiControl.isInterface.setCacheSize(cacheSize);

	 guiControl.displayPane.refreshDisplay();
       }


 
}


