package DisplayGUI;
import java.awt.event.*;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JCheckBox;
import javax.swing.JPopupMenu;

import Preferences.*;
import guiUtilities.ChoiceDialog;
//
import Sct.Version;
import Sct_CalibrationController.TestRequest;
import Sct_CalibrationController.SequenceRequest;

import GuiComponents.System.*;
import GuiComponents.scripting.*;
import GuiComponents.Console.JConsole;

import Sct_SctApi.*;
import Sct.*;
import sctConf.*;
import SctData.*;
import Sct.IS.*;

/** Menu bar for GUI */
public class MenuActions implements displayParams,TestDataInfo {
    gui guiControl;

    private SystemInterface si;
    String option;

    private JMenu sctdbSCTDAQOptionMenu,sctdbRODDAQOptionMenu, panelsctdbSCTDAQOptionMenu,panelsctdbRODDAQOptionMenu;

    public boolean enableAutoUpload=false;
    JMenuItem autoAssemblyUploadItem;

    private JMenuItem testReportItem;



    int itemIndex;


    public MenuActions(gui parent) {
	guiControl=parent;
    }


    public JMenuBar createMenuBar() {

		JMenuBar mb = new JMenuBar();

       mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_SYSTEM));
       mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_DISPLAY));
	   mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_TESTMENU));
// Options menu
       sctdbSCTDAQOptionMenu = getDBSCTDAQDataOptionMenu(false);
       sctdbRODDAQOptionMenu = getDBRODDAQDataOptionMenu(false);
       JMenu menu = new JMenu("Options");
       menu.setBackground(backgroundColor);
       menu.setFont(menuFont);
       menu.setForeground(menuColor);


       menu.add(guiControl.guiMenus.getMenu(GuiMenus.OPTIONS_CONFIG));
       menu.add(guiControl.guiMenus.getMenu(GuiMenus.OPTIONS_DISPLAY));

       JMenu sctdbMenu = new JMenu("SCT Database");
       sctdbMenu.setFont(menuFont);
       sctdbMenu.add(sctdbSCTDAQOptionMenu);
       sctdbMenu.add(sctdbRODDAQOptionMenu);
       sctdbMenu.add(getAssemblyOptionMenu());
       menu.add(sctdbMenu);

       menu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DCS));
      
       menu.add(getBookkeepingMenu());

       mb.add(menu);

       panelsctdbSCTDAQOptionMenu = getDBSCTDAQDataOptionMenu(true);
       panelsctdbRODDAQOptionMenu = getDBRODDAQDataOptionMenu(true);


// Tools menu

      mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_TOOLS));
      mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_HELP));
      mb.add(javax.swing.Box.createHorizontalGlue());
      mb.add(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_PREFERENCES));

      mb.setBorder(javax.swing.BorderFactory.createEmptyBorder());
      mb.setBackground(backgroundColor);
	  return mb;
   }

//********************************************************
    public void enableCCMenuItems(boolean enabled) {
    	guiControl.guiMenus.enableSubMenuItems(guiControl.guiMenus.getMenu(GuiMenus.PANEL_TESTMENU),enabled);
		guiControl.guiMenus.enableSubMenuItems(guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_TESTMENU),enabled);
		}



    public void enableDisplayMenuItems(boolean enabled) {
		guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY).setEnabled(enabled);
		guiControl.guiMenus.getMenu(GuiMenus.MENUBAR_DISPLAY).setEnabled(enabled);
    }


    protected boolean addNewConsole(Interpreter interpreter, String suffix) {
	if (interpreter == null) {
	    System.out.println("Can only have 1 scripting window open at once\n");
            return false;
        }
        javax.swing.JFrame frame = new javax.swing.JFrame();
        javax.swing.JScrollPane scroll = new javax.swing.JScrollPane();
        scroll.setViewportView(interpreter.getConsole());
        frame.getContentPane().add(scroll);
        frame.setTitle("Scripting Window:" + suffix);
        frame.setVisible(true);
        frame.setSize(800, 500);
        return true;
    }


//**********************************************
// popup menus for tables
   public void showTablesPopupMenu(int clickedTable, MouseEvent e) {
        JPopupMenu pMenu;
        switch(clickedTable) {
        case 1:
          switch(guiControl.displayStatus.getStatus()) {
	    case DisplayStatus.MODULE_GROUP_SELECTION:
		if(guiControl.selectorPane.getDisplayParameterIndex()>0) {
			pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_BOC).getPopupMenu();
            pMenu.show(e.getComponent(),e.getX(),e.getY());
			pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_BOC));
			}
            break;

            case DisplayStatus.IS_MONITOR:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_DATA_MANAGER).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_DATA_MANAGER));
              break;
            case DisplayStatus.TEST_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_RESULTS).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_RESULTS));
              break;
            case DisplayStatus.SCTDB_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_SCTDB).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_SCTDB));
              break;
            case DisplayStatus.SCTDB_RODDAQ_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_SCTDB).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_SCTDB));
              break;
            case DisplayStatus.IV_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_IVSCAN).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_IVSCAN));
              break;
           case DisplayStatus.DCS_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.MODULE_DCS).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.MODULE_DCS));
              break;
            default:
          }
          break;
         case 0:
          switch(guiControl.displayStatus.getStatus()) {
            case DisplayStatus.IS_MONITOR:
              pMenu = getTable0Menu().getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
//              pMenu.setInvoker(tableDataOptionMenu);
              break;
            case DisplayStatus.TEST_DATA:
              pMenu = guiControl.guiMenus.getMenu(GuiMenus.TEST_FILTER).getPopupMenu();
              pMenu.show(e.getComponent(),e.getX(),e.getY());
              pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.TEST_FILTER));
              break;
            default:
          }
          break;
         default:
         }

        }

   public void showRODMenu(MouseEvent e) {
   		JPopupMenu pMenu;
        JMenu newMenu = new JMenu();
	  JMenuItem item = new JMenuItem("ROD Diagnostic...");
		item.setFont(menuFont);
		newMenu.add(item);
        item.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
				showRodDiagnosticWindow();
				 }
           		});
        pMenu = newMenu.getPopupMenu();
        pMenu.show(e.getComponent(),e.getX(),e.getY());
        pMenu.setInvoker(newMenu);
		}

   public void showTIMRegisterMenu(MouseEvent e) {
   		JPopupMenu pMenu;
        JMenu newMenu = new JMenu();
	  JMenuItem item = new JMenuItem("TIM Registers...");
		item.setFont(menuFont);
		newMenu.add(item);
        item.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
				javax.swing.JOptionPane.showMessageDialog(null,"TIM Register gui not yet ready...Try again soon!");
				 }
           		});
        pMenu = newMenu.getPopupMenu();
        pMenu.show(e.getComponent(),e.getX(),e.getY());
        pMenu.setInvoker(newMenu);
		}


   public void showPopupMenu(MouseEvent e) {
        JPopupMenu pMenu;
        JMenu newMenu = new JMenu();
        switch(guiControl.displayStatus.getStatus()) {
        case DisplayStatus.UNDEFINED:
           pMenu = guiControl.guiMenus.getMenu(GuiMenus.OPTIONS_CONFIG).getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.OPTIONS_CONFIG));
           break;  
        case DisplayStatus.MODULE_GROUP_SELECTION:
	     if(guiControl.selectorPane.getDisplayParameterIndex()==0) {
           		pMenu = guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY).getPopupMenu();
           		pMenu.show(e.getComponent(),e.getX(),e.getY());
           		pMenu.setInvoker(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
			}
		else {
			JMenuItem item = new JMenuItem("ReRead BOC Data");
			item.setFont(menuFont);
			newMenu.add(item);
          		item.addActionListener(new java.awt.event.ActionListener() {
            		public void actionPerformed(java.awt.event.ActionEvent evt) {
		  		try {
                 		SctApiInfo.getInstance().probeConfig(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex(),guiControl.selectorPane.getDisplayParameterIndex());
		     			guiControl.displayPane.setDisplayColors();
		     			guiControl.displayPane.refreshDisplay();
		     			guiControl.tablesDisplayPane.updateTables();
		    		}catch(Exception e){javax.swing.JOptionPane.showMessageDialog(null,"SctApi Exception "+e.toString());}
            		}
           		});
			newMenu.addSeparator();
			newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           		pMenu = newMenu.getPopupMenu();
           		pMenu.show(e.getComponent(),e.getX(),e.getY());
           		pMenu.setInvoker(newMenu);
			}
           break;  
        case DisplayStatus.IS_MONITOR:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_TESTMENU));
           newMenu.addSeparator();
           JMenuItem rItem = new JMenuItem("Retrieve Archived Data");
           rItem.setFont(menuFont);
           newMenu.add(rItem);
           rItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               ArchiveQueryBox b = new ArchiveQueryBox(guiControl);
               b.setLocationRelativeTo(guiControl);
               b.setVisible(true);
            }
           });

//           pMenu = testMenu.getPopupMenu();
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
//           pMenu.setInvoker(testMenu);
           pMenu.setInvoker(newMenu);
           break;  
        case DisplayStatus.TEST_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_TESTMENU));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_TESTDATA));
	   // special options for RxThreshold---------------
	   TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
	   if(testSelection!=null && testSelection.getTestIndex()==TEST_RXTHRESHOLDBASEDONCONFIGREGISTER) {
	      JMenuItem item = new JMenuItem("RxThreshold Comparison Report...");
	      item.setFont(menuFont);
              item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    String txt = javax.swing.JOptionPane.showInputDialog(null,"List channels with RxThreshold shifted by more than:","10");
	            if(txt==null) return;
		    try {
		     int shift = Integer.valueOf(txt).intValue();
		     if(shift<0) {
		        javax.swing.JOptionPane.showMessageDialog(null,"Shift must be a positive number.");
			return;
			}
                     java.util.Vector theTable = checkBOCRxThresholds(shift);
		     if(theTable==null) return;
		     if(theTable.size()>1) guiUtilities.SpreadsheetViewer.getInstance().update("Comparison of optimised RxThresholds with with XML file settings for channels with RxThreshold shift greater than "+txt,theTable);
                     else javax.swing.JOptionPane.showMessageDialog(null,"All RxThreshold values in the xml files are within "+shift+" counts of the optimal values.");
		     }catch(Exception e){javax.swing.JOptionPane.showMessageDialog(null,"You must enter a positive number.");}
		     }
              });
             newMenu.add(item);
	     item = new JMenuItem("Update XML Files...");
	     item.setFont(menuFont);
             item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
	     	    String txt = javax.swing.JOptionPane.showInputDialog(null,"Update files if RxThreshold shifted by more than:","10");
	           if(txt==null) return;
		    try {
		     int shift = Integer.valueOf(txt).intValue();
		     if(shift<0) {
		        javax.swing.JOptionPane.showMessageDialog(null,"Shift must be a positive number.");
			return;
			}
                     java.util.Vector theTable = checkBOCRxThresholds(shift);
		     if(theTable==null) return;
		     System.out.println("theTable has size "+theTable.size());
		     if(theTable.size()>1) {
                         RxThresholdData rxFileData = RxThresholdData.getInstance();
		         rxFileData.updateXMLfiles(theTable,shift);
		         if(rxFileData.getErrorString()!=null) {
		           javax.swing.JOptionPane.showMessageDialog(null,rxFileData.getErrorString());
			   return;
		            }
			 }
                     else javax.swing.JOptionPane.showMessageDialog(null,"No updates made. All RxThreshold values in the xml files are within "+shift+" counts of the optimal values.");
		     }catch(Exception e){javax.swing.JOptionPane.showMessageDialog(null,"You must enter a positive number.");}
		     }
              });
	      newMenu.add(item);
	   }
	   //------------------------------------------------
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
        case DisplayStatus.SCTDB_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(panelsctdbSCTDAQOptionMenu);
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
        case DisplayStatus.SCTDB_RODDAQ_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(panelsctdbRODDAQOptionMenu);
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
        case DisplayStatus.DCS_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_TESTMENU));
	   	   newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DCS));
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
        case DisplayStatus.IV_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.OPTIONS_IVSCAN));
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
        case DisplayStatus.PROBE_DATA:
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_DISPLAY));
           newMenu.add(guiControl.guiMenus.getMenu(GuiMenus.PANEL_PROBE));
           pMenu = newMenu.getPopupMenu();
           pMenu.show(e.getComponent(),e.getX(),e.getY());
           pMenu.setInvoker(newMenu);
           break;
  
        default:
           }
        }

//**************************************************************************
    private JMenu getBookkeepingMenu() {
       JMenu thisMenu = new JMenu("BookKeeping");
       thisMenu.setFont(menuFont);

       BookKeeper sbk = BookKeeper.getInstance();

       thisMenu.add(sbk.bookkeepingEnabledItem);


       thisMenu.addSeparator();

       thisMenu.add(sbk.runPromptEnabledItem);
       thisMenu.add(sbk.testPromptEnabledItem);

       return thisMenu;
       }
//**************************************************************************
    private JMenu getTable0Menu() {
       JMenu thisMenu = new JMenu("Data Manager - table0");

       thisMenu.setFont(menuFont);

       JMenuItem item = new JMenuItem("Add/Edit Run Comments...");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                         TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
                         if(testSelection==null) {
                             javax.swing.JOptionPane.showMessageDialog(null,"No test selected.");
                             return;
                             }
                         BookKeeper.getInstance().showCommentPrompt(testSelection.getRunNo(), testSelection.getScanNo(), null);
                 }
             });
       thisMenu.add(item);

       item = new JMenuItem("Add/Edit Test Comments...");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                         TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
                         if(testSelection==null) {
                             javax.swing.JOptionPane.showMessageDialog(null,"No test selected.");
                             return;
                             }
                         BookKeeper.getInstance().showCommentPrompt(testSelection.getRunNo(), testSelection.getScanNo(), testSelection.getTestName());                          
                 }
             });
       thisMenu.add(item);

       thisMenu.addSeparator();

       item = new JMenuItem("Delete Selected Test(s)");
       item.setFont(menuFont);
       item.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                         TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
                         if(testSelection==null) {
                             javax.swing.JOptionPane.showMessageDialog(null,"No data selected.");
                             return;
                             }
                         int selectedRow = guiControl.tablesDisplayPane.getSelectedTest();
                         int response = javax.swing.JOptionPane.showConfirmDialog(null,"Delete "+testSelection.getTestName()+" test for Run/Scan "+testSelection.getRunNo()+"/"+testSelection.getScanNo()+"?","Confirm Deletion",javax.swing.JOptionPane.YES_NO_OPTION,javax.swing.JOptionPane.QUESTION_MESSAGE);
                         if(response==javax.swing.JOptionPane.NO_OPTION) return;
                         guiControl.isInterface.removeTests(guiControl.tablesDisplayPane.getTestControlObjectNames(),selectedRow,selectedRow); 
                         guiControl.tablesDisplayPane.updateTables();                       
                 }
             });
       thisMenu.add(item);



       return thisMenu;
       }

    private void setAssemblyUploadItem() {
    	autoAssemblyUploadItem.setText(enableAutoUpload ? "Disable auto-upload of module positions" : "Enable auto-upload of module positions");
	}
//****************************************************************************************
    private JMenu getAssemblyOptionMenu() {
       JMenu thisMenu = new JMenu("Assembly");
//       thisMenu.setBackground(backgroundColor);
       thisMenu.setFont(menuFont);
//       thisMenu.setForeground(menuColor);

	 autoAssemblyUploadItem = new JMenuItem("Item");
       autoAssemblyUploadItem.setFont(menuFont);
	 enableAutoUpload = PreferencesInterface.getInstance().getPreference(PreferencesInterface.ASSEMBLY_UPLOADS).equals("TRUE");
       setAssemblyUploadItem();
       autoAssemblyUploadItem.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                    enableAutoUpload = !enableAutoUpload;
			  setAssemblyUploadItem();
                    PreferencesInterface.getInstance().setPreference(PreferencesInterface.ASSEMBLY_UPLOADS,enableAutoUpload ? "TRUE" : "FALSE");
                 }
             });
       thisMenu.add(autoAssemblyUploadItem);

       thisMenu.addSeparator();

       JMenuItem item = new JMenuItem("Upload Module Assembly Positions");
       item.setFont(menuFont);
       thisMenu.add(item);
       item.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.isInterface.uploadAssemblyInfo();
                   }
              });

       return thisMenu;
       }

//****************************************************************************************
    private JMenu getDBSCTDAQDataOptionMenu(boolean isPanel) {
       JMenu thisMenu = new JMenu("SCTDAQ Reference");
//       thisMenu.setBackground(backgroundColor);
       thisMenu.setFont(menuFont);
//       thisMenu.setForeground(menuColor);
       JMenuItem item = new JMenuItem("Download SCTDAQ Reference Data");
       item.setFont(menuFont);
       thisMenu.add(item);
       item.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   guiControl.isInterface.downloadTests(-1);
                   }
              });
       item = new JMenuItem("SCTDAQ Test Location ...");
       item.setFont(menuFont);
       thisMenu.add(item);
       item.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                 java.util.Vector listOfLocations = new java.util.Vector();
                 try {
                      listOfLocations = ProdDatabase.GeneralUtilities.getLocationList();
                 }catch(Exception e2){}
                 listOfLocations.insertElementAt("Any",0);
                 guiUtilities.userPrompt thisPrompt = new guiUtilities.userPrompt(guiControl,"Any","Institute", listOfLocations);
                 thisPrompt.pack();
                 thisPrompt.setLocationRelativeTo(guiControl);
                 thisPrompt.setVisible(true);
                 String thisLocation = thisPrompt.getValidatedText();
                 if (!thisLocation.equals("None")) {
                      guiControl.isInterface.setLocation(thisLocation);
//                      guiControl.isInterface.setTestFilter(guiControl.tablesDisplayPane.getTestControlObjectName());
                      guiControl.selectorPane.initParamList(); // maybe require change of parameter menu
                      guiControl.colorScalePane.setColorScale(); // ditto for color scale
                      guiControl.displayPane.setDisplayColors();
                      guiControl.displayPane.refreshDisplay();
                      guiControl.tablesDisplayPane.listTestResults();
                      }

                   }
              });
       return thisMenu;
       }
//****************************************************************************************
    private JMenu getDBRODDAQDataOptionMenu(boolean isPanel) {
       JMenu thisMenu = new JMenu("SctRodDaq Downloads");
//       thisMenu.setBackground(backgroundColor);
       thisMenu.setFont(menuFont);
//       thisMenu.setForeground(menuColor);

       JMenuItem item = new JMenuItem("Download SctRodDaq Data ...");
       item.setFont(menuFont);
       thisMenu.add(item);
       item.addActionListener(new java.awt.event.ActionListener() {
             public void actionPerformed(java.awt.event.ActionEvent evt) {
                   new DatabaseLister().show();                   
                   }
              });

       return thisMenu;
       }



   public void updateMenuStates() {
//      switch(guiControl.displayStatus.getStatus()) {
//         case DisplayStatus.IS_MONITOR:
//             enableDataManagerItems(true);
//             break;
//         default:
//             enableDataManagerItems(false);
//         }
    }



   public void plotIVScanData(String serialNo) {
     	IVTestSelection ivTestSelection = guiControl.tablesDisplayPane.getIVTestSelection();
        if(ivTestSelection==null) {
          	javax.swing.JOptionPane.showMessageDialog(null,"No IV Scan selected.");
            return;
            }
        String summary = "IV Scan Plots for Run "+Integer.toString(ivTestSelection.getRunNo())+", Scan "+Integer.toString(ivTestSelection.getScanNo());
        DisplayGUI.plotters.IVScansData ivScansData = new DisplayGUI.plotters.IVScansData(summary);
       	for (java.util.Iterator m = ConfigurationInterface.getInstance().getSerialNumberList(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex()).iterator(); m.hasNext(); ) {
        	String sn=(String)m.next();
            SummaryReader.IVData ivData = guiControl.isInterface.getIVData(ivTestSelection.getResultObjectHeader(),sn);
            if(ivData!=null) ivScansData.add(sn,ivData.getDataPointSet());
            }
        DisplayGUI.plotters.IVPlotDisplay ivPlotDisplay = new DisplayGUI.plotters.IVPlotDisplay();
        ivPlotDisplay.showData(ivScansData,serialNo);
        }

       
   private java.util.Vector checkBOCRxThresholds(int shift) {
                  TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
                  int testIndex = (testSelection!=null) ? testSelection.getTestIndex() : -1;
		  if(testIndex==-1) {
		    javax.swing.JOptionPane.showMessageDialog(null,"No test is currently selected.");
		    return null;
		    }

		    
		  RxThresholdData rxFileData = RxThresholdData.getInstance();
		  rxFileData.refresh();
		  if(rxFileData.getErrorString()!=null) {
		     javax.swing.JOptionPane.showMessageDialog(null,rxFileData.getErrorString());
		     return null;
		     }
		  java.util.Vector theTable = new java.util.Vector();
		  java.util.Vector theLine = new java.util.Vector();
		  theLine.addElement("Serial No");    // string
		  theLine.addElement("Stream");       // Integer
		  theLine.addElement("MUR");          // String
		  theLine.addElement("Module ID");    // String
		  theLine.addElement("Optimal RxThr");// String
		  theLine.addElement("File Value");   // String
		  theLine.addElement("Shift");        // Integer
		  theTable.addElement(theLine);

// enumerate through all modules
       	for (java.util.Iterator m = ConfigurationInterface.getInstance().getSerialNumberList(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex()).iterator(); m.hasNext(); ) {
        	String sn=(String)m.next();
		    for(int stream=0;stream<2;stream++) {
		       theLine = new java.util.Vector();
		       theLine.addElement(sn);
		       theLine.addElement(new Integer(stream));
		       theLine.addElement(rxFileData.getMurID(sn));
		       theLine.addElement(rxFileData.getModuleID(sn));
		       String resultObjectHeader = testSelection.getResultObjectHeader();
		       SummaryReader.Test testResult = guiControl.isInterface.getTest(resultObjectHeader,sn,null);
                       Double rxData = testResult.getLinkInfo().get(stream,2);  // link 0, 2 is Best Rx Threshold
		       int rxDataInt = (int)rxData.doubleValue();
		       theLine.addElement(Integer.toString(rxDataInt));
		       String fileData = rxFileData.getStreamFileData(sn,stream);
		       if(fileData==null)continue;
		       theLine.addElement(fileData);
		       Integer fileDataInteger = guiUtilities.DaveUtils.getIntFromHex(fileData); // fileData might be an integer or in hex
		       if(fileDataInteger==null) continue;
		       int diff = (rxDataInt==-1) ? -1 : rxDataInt - fileDataInteger.intValue();
		       if(Math.abs(diff)<=shift) continue;
		       theLine.addElement(new Integer(diff));

		       theTable.addElement(theLine);
		       }
		    }
		  return theTable;
		  }

			
			
			
			

       
   public void makeComparisonReport(boolean isSCTDAQ) {
                  Object[] runList=null;
                  TestSelection testSelection = guiControl.tablesDisplayPane.getTestSelection();
                  int testIndex = (testSelection!=null) ? testSelection.getTestIndex() : -1;
		  if(testIndex==-1) {
		    javax.swing.JOptionPane.showMessageDialog(null,"No test is currently selected.");
		    return;
		    }
		  if(!testIsSCTDAQ[testIndex]) {
		    javax.swing.JOptionPane.showMessageDialog(null,testNames[testIndex]+" is not a SCTDAQ test - no reference comparison is possible.");
		    return;
		    }
		  java.util.Vector sctdbObjectHeaderList = new java.util.Vector();
                  if(isSCTDAQ) sctdbObjectHeaderList.addElement(testSelection.getSCTDBObjectHeader());
		  else {
                     java.util.Vector vTest = new java.util.Vector();
		     String[] objectList = guiControl.isInterface.getDBISObjects(testIndex);

		     if(objectList.length==0) {
		        javax.swing.JOptionPane.showMessageDialog(null,"There is no "+testNames[testIndex]+" SctRodDaq reference data yet downloaded\nPlease download data from the Options menu or via the SctRodDaq Reference display.");
			return;
			}
		     guiUtilities.ChoiceDialog rnd = new guiUtilities.ChoiceDialog(guiControl,"Choose Reference Data",90,16,objectList,true);
		     rnd.pack();
                     rnd.setLocationRelativeTo(guiControl);
                     rnd.setVisible(true);
		     runList = rnd.getSelectedObjects();
		     if(runList==null || runList.length==0) return;

		     for(int k=0;k<runList.length;k++) {
		         String sctdbObject = (String)runList[k];
			 //System.out.println("adding ref "+sctdbObject);
			 java.util.regex.Matcher matcher = ISInterface.SctRodDaqRefPattern.matcher(sctdbObject);
			 if(matcher.matches()) {
			 // control object name, followed by institute name
		            TestSelection thisSel = new TestSelection(sctdbObject,sctdbObject.substring(matcher.start(ISInterface.LOCATION),matcher.end(ISInterface.LOCATION)));
			    //System.out.println("adding "+thisSel.getSCTDBRodDaqObjectHeader());
                            sctdbObjectHeaderList.addElement(thisSel.getSCTDBRodDaqObjectHeader());
			    }
			 }
		  }

		  String header = testSelection.getResultObjectHeader();

		  java.util.Vector theTable = new java.util.Vector();
		  java.util.Vector theLine = new java.util.Vector();
		  theLine.addElement("Serial No");
		  theLine.addElement("Parameter");
		  theLine.addElement("Tolerance");
		  theLine.addElement("SctRodDaq Data");
		  theLine.addElement("Reference Data");
		  theLine.addElement("Comments");
		  theTable.addElement(theLine);

		  String resultObjectHeader = testSelection.getResultObjectHeader();
		  java.util.regex.Pattern defectPattern = java.util.regex.Pattern.compile("^[^-]+-(.*)");
		  java.util.regex.Matcher matcher;


// enumerate through all modules

		  for (java.util.Iterator i = ConfigurationInterface.getInstance().getSerialNumberList(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex()).iterator(); i.hasNext(); ) {

            String sn=(String)i.next();
		    ModuleConfiguration mConfig=null;
		    try {
		       Sct_SctApi.SctApiIPC api = SystemInterface.getInstance().getSctApi();
	               if (api != null) {
		       int mid = api.findModuleSerial(sn);
                           ABCDModule data = api.retrieveModule(mid);
                           mConfig = new ModuleConfiguration(data);
			   }
		    }catch(Exception e2){System.err.println("SctGUI: Cannot access module config for module "+sn);}

		    SummaryReader.Test newTestResult = guiControl.isInterface.getTest(resultObjectHeader,sn,null);
		    if(newTestResult==null) continue;
		    SummaryReader.Test refTestResult = null;
		    HEADERLOOP:
		    for(int j=0;j<sctdbObjectHeaderList.size();j++) {
		       String sctdbObject = (String)sctdbObjectHeaderList.elementAt(j)+sn;

		       if(SctNames.getISRepository().contains(sctdbObject)) {
                          refTestResult = guiControl.isInterface.getSCTDBTest(sctdbObject);
			  break HEADERLOOP;
			  }
                       }

//		    refTestResult = guiControl.isInterface.getSCTDBTest(sctdbObjectHeader+sn);
		    if(refTestResult==null) {
		    	theLine = new java.util.Vector();
		        theLine.addElement(sn);
		        theLine.addElement("n/a");
		        theLine.addElement("n/a");
		        theLine.addElement("n/a");
		        theLine.addElement("NO DATA");
		        theLine.addElement("Please download reference data");
		        theTable.addElement(theLine);
                        continue;
			}


		    // first look for defects
		    java.util.Map refDefectKeys = new java.util.HashMap();
		    for(int k=0;k<refTestResult.getNoDefects();k++) {
		       SummaryReader.DefectInfo defectInfo = refTestResult.getDefectInfo(k);
		       String defectKey = defectInfo.getDefectKey();
		       matcher = defectPattern.matcher(defectKey);
		       String chans = matcher.matches() ? defectKey.substring(matcher.start(1),matcher.end(1)) : defectKey;
		       refDefectKeys.put(chans,defectInfo.getName());
		//       System.out.println(sn+" ref defect: "+defectInfo.getDefectKey()+" with name "+defectInfo.getName());
		       }
		    for(int k=0;k<newTestResult.getNoDefects();k++) {
		      SummaryReader.DefectInfo defectInfo = newTestResult.getDefectInfo(k);
                      String newKey = defectInfo.getDefectKey();
		      matcher = defectPattern.matcher(newKey);
		      String chans = matcher.matches() ? newKey.substring(matcher.start(1),matcher.end(1)) : newKey;
		      String newName = defectInfo.getName();
		//      System.out.println(sn+" new defect "+newKey+" with name "+newName);
		      if(refDefectKeys.containsKey(chans)) {
		//        System.out.println("**matches refdata");
		        String name = (String)refDefectKeys.get(chans);
			if(name.equals(newName)) continue;
		//	System.out.println("** with different name");
		        theLine = new java.util.Vector();
		        theLine.addElement(sn);
		        theLine.addElement("Defects");
		        theLine.addElement("Zero");
		        theLine.addElement(chans+" ("+newName+")");
		        theLine.addElement(chans+" ("+name+")");
		        theLine.addElement("Different defect type");
		        theTable.addElement(theLine);
                        continue;
			}
		      theLine = new java.util.Vector();
		      theLine.addElement(sn);
		      theLine.addElement("Defects");
		      theLine.addElement("Zero");
		      theLine.addElement(chans+" ("+newName+")");
		      theLine.addElement("Not Present");
		      theLine.addElement("NEW DEFECT");
		      theTable.addElement(theLine);
		      }

		     java.util.Map newDefectKeys = new java.util.HashMap();
		    for(int k=0;k<newTestResult.getNoDefects();k++) {
		       SummaryReader.DefectInfo defectInfo = newTestResult.getDefectInfo(k);
		       String defectKey = defectInfo.getDefectKey();
		       matcher = defectPattern.matcher(defectKey);
		       String chans = matcher.matches() ? defectKey.substring(matcher.start(1),matcher.end(1)) : defectKey;
		       newDefectKeys.put(chans,defectInfo.getName());
		       }
		    for(int k=0;k<refTestResult.getNoDefects();k++) {
		      SummaryReader.DefectInfo defectInfo = refTestResult.getDefectInfo(k);
                      String refKey = defectInfo.getDefectKey();
		      matcher = defectPattern.matcher(refKey);
		      String chans = matcher.matches() ? refKey.substring(matcher.start(1),matcher.end(1)) : refKey;
		      String refName = defectInfo.getName();
		      if(!newDefectKeys.containsKey(chans)) {
		      	 theLine = new java.util.Vector();
		         theLine.addElement(sn);
		         theLine.addElement("Defects");
		         theLine.addElement("Zero");
		         theLine.addElement("Not Present");
		         theLine.addElement(chans+"  ("+refName+")");
		         theLine.addElement("Old defect no longer present");
		         theTable.addElement(theLine);
		         }
                       }

		    PARAMLOOP:
                    for(int parameterIndex=0;parameterIndex<testParameters[testIndex].length;parameterIndex++) {
		      if(!testIsDefined[testIndex]) continue;
		      if(!doComparisons[testIndex][parameterIndex]) continue;
		      for(int k=4;k<chipOptions.length;k++) {
		        Double newData = newTestResult.getLastDataBlock().get(k,parameterIndex-parameterOffset);
		        Double refData = (refTestResult!=null) ? refTestResult.getLastDataBlock().get(k,parameterIndex-parameterOffset) : null;
		        if(refData==null) {
		          theLine = new java.util.Vector();
		          theLine.addElement(sn);
		          theLine.addElement(testParameters[testIndex][parameterIndex]);
		          theLine.addElement(Double.toString(testDataTolerances[testIndex][parameterIndex]));
		          theLine.addElement(newData.toString());
		          theLine.addElement("NO DATA");
		          theLine.addElement("Please download reference data!");
		          theTable.addElement(theLine);
		          break PARAMLOOP;
		          }
			double referenceData = refData.doubleValue();
			if(isSCTDAQ) {
			try {
			// apply cfactor corrections if appropriate, as sctdaq was taken with cfactor=1.0
			switch(testIndex) {
			   case TEST_3PTGAIN:
			   case TEST_NPTGAIN:
			     if(mConfig!=null) {
			       double cfactor =  (double)mConfig.getChipConfiguration(k-4).getCalFactor();
			       if(parameterIndex==11) referenceData *= cfactor;
			       else if(parameterIndex==6) referenceData /= cfactor;
			       }
			   break;
			   case TEST_NOISE:
			      if(mConfig!=null && parameterIndex==7) {
			      	double cfactor =  (double)mConfig.getChipConfiguration(k-4).getCalFactor();
			        referenceData *= cfactor;
			        }
			   break;
			   default:
			   }
			}catch(Exception e3){System.err.println("Exception retrieving cfactor for chip "+Integer.toString(k-4)+", module "+sn);}
			}


                        double diff = newData.doubleValue()-referenceData;
		        if(Math.abs(diff)>testDataTolerances[testIndex][parameterIndex]) {
		          theLine = new java.util.Vector();
		          theLine.addElement(sn);
		          theLine.addElement(testParameters[testIndex][parameterIndex]);
		          theLine.addElement(Double.toString(testDataTolerances[testIndex][parameterIndex]));
		          theLine.addElement(newData.toString());
			  theLine.addElement(refData.toString());
			  String label = (diff>0.) ? "too high" : "too Low";
			  theLine.addElement(chipOptions[k]+" data "+label);
			  theTable.addElement(theLine);
			  }
		       } // loop on chip
		    } // loop on parameterIndex
		  } // loop on moduleList
		  if(theTable.size()==1) { // titles only!
		    StringBuffer b = new StringBuffer("SctRodDaq in good agreement with SCTDAQ Reference Data");
		    b.append("\nfor "+testNames[testSelection.getTestIndex()]+" Run "+Integer.toString(testSelection.getRunNo())+" Scan "+Integer.toString(testSelection.getScanNo()));
		    b.append("\nParameters compared:");
                    for(int parameterIndex=0;parameterIndex<testParameters[testIndex].length;parameterIndex++) {
		      if(testIsDefined[testIndex] && doComparisons[testIndex][parameterIndex]) b.append("\n"+testParameters[testIndex][parameterIndex]);
		      }
		    javax.swing.JOptionPane.showMessageDialog(null,b.toString());
		    return;
		    }
                   String param = "None";
		   if(isSCTDAQ) param = "SctRodDaq/SCTDAQ Discrepancy List for "+testNames[testSelection.getTestIndex()]+" Run "+Integer.toString(testSelection.getRunNo())+" Scan "+Integer.toString(testSelection.getScanNo());
		   else {
		      StringBuffer dText = new StringBuffer();
		      for(int k=0;k<runList.length;k++) {
		         String ob = (String)runList[k];
			 matcher = ISInterface.SctRodDaqRefPattern.matcher(ob);
			 if(matcher.matches()) {
			   if(k<0) dText.append(" and Run/Scan ");
			   else dText.append(",");
			   dText.append(ob.substring(matcher.start(ISInterface.RUNNO),matcher.end(ISInterface.RUNNO))+"/"+ob.substring(matcher.start(ISInterface.SCANNO),matcher.end(ISInterface.SCANNO)));
		           }
			 }
		     param =testNames[testSelection.getTestIndex()]+" Comparison between new data (Run/Scan "+Integer.toString(testSelection.getRunNo())+"/"+Integer.toString(testSelection.getScanNo())+") and "+dText.toString();
                     }
		   guiUtilities.SpreadsheetViewer.getInstance().update(param,theTable);
		   }

	public void showRodDiagnosticWindow() {
			ConfigurationInterface config = ConfigurationInterface.getInstance();
			int slot = guiControl.displayPane.getLastClickedRodSlot();
			if(slot<0) return;
			String sn = config.getASerialNumberForSlot(guiControl.selectorPane.getViewIndex(),slot);
                  if(sn==null) return;
			javax.swing.JFrame rodFrame = new javax.swing.JFrame("ROD diagnostics");
			int partition = Integer.parseInt(config.getSNInfo(sn,SNInfo.PARTITION));
			int crate = Integer.parseInt(config.getSNInfo(sn,SNInfo.ROD_CRATE));
			int rod = Integer.parseInt(config.getSNInfo(sn,SNInfo.ROD_NUMBER));
			try {
				java.awt.Component c = (java.awt.Component)new GuiComponents.SctApi.RodDiagnostics(partition, crate, rod, SystemInterface.getInstance().getSctApi());
            	rodFrame.getContentPane().add(c);
            	rodFrame.pack();
            	rodFrame.setVisible(true);
			}catch(Exception e2){javax.swing.JOptionPane.showMessageDialog(null,"Exception"+e2.toString());}
   }

}

