/*
 * IndexTable.java
 *
 *
 */

package DisplayGUI;
import javax.swing.JTable;
import javax.swing.event.*;
import javax.swing.table.TableModel;
import javax.swing.ListSelectionModel;
import java.util.Vector;
/**
 *
 * @author  robinson
 */
public class ResultsTable extends GuiTable implements TableModelListener {



public ResultsTable(gui parent) {
	super(parent);
	guiControl=parent;
      table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     	table.addMouseListener(new tablesMouseAdapter());

	}

public Vector getISTableList(ModuleCell thisCell) {

       Vector theLine;
       java.util.SortedMap m = new java.util.TreeMap();

	 TestSelection testSelection = guiControl.tablesDisplayPane.indexTable.getTestSelection();

       if(thisCell!=null && testSelection!=null && testSelection.getRunScanRegex()!=null) {
       String thisSN = thisCell.getSerialNo();
       java.util.List isList = (java.util.List)guiControl.isInterface.isCounter.getModuleList(guiControl.selectorPane.getDisplayParameterIndex(),testSelection.getRunScanRegex(),thisSN,testSelection.isRetrievedData());
       if(isList==null) objectNames = new Vector();
       else {
         objectNames = new Vector(isList);
         for(int i=0;i<objectNames.size();i++) {
            String[] objectParts = ((String)objectNames.elementAt(i)).split("\\.");
            theLine = new Vector();
            String sn = objectParts[4];
            Integer runNo = Integer.valueOf(objectParts[2]);
            Integer scanNo = Integer.valueOf(objectParts[3]);
            String fname = objectParts[1];
            theLine.add(sn);
            theLine.add(runNo);
            theLine.add(scanNo);
            theLine.add(fname);
            m.put(new Integer(runNo.intValue()*10000 + scanNo.intValue()),theLine);
            }
          }
         }
         Vector tableContents = new Vector(m.values());
         theLine=new Vector();
         theLine.addElement("Serial No");
         theLine.addElement("Run No");
         theLine.addElement("Scan No");
         theLine.addElement("Data");
         tableContents.insertElementAt(theLine,0);
         return tableContents;
        }

class tablesMouseAdapter extends java.awt.event.MouseAdapter {
            public void mouseClicked(java.awt.event.MouseEvent e) {
               switch(e.getModifiers()) {
                 case java.awt.event.InputEvent.BUTTON2_MASK:
                 case java.awt.event.InputEvent.BUTTON3_MASK:
	               int rowSelect = table.rowAtPoint(new java.awt.Point(e.getX(),e.getY()));
                     rowSM.setSelectionInterval(rowSelect,rowSelect);
	               if(rowSelect<0) return;
			   String sn = (String)resultTable.getValueAt(rowSelect,0);
			   if(sn.matches("\\d{14}")) guiControl.displayPane.setLastClickedCell(sn);
			   else System.out.println("SctGUI::TablesDisplayPane - invalid serial no "+sn);
//                     guiControl.menuActions.setSelectedSerialNo((String)resultTable[1].getValueAt(rowSelect,0));
                     guiControl.menuActions.showTablesPopupMenu(1,e);
                     break;
                 default:
                 }
            }
    }

}
