package DisplayGUI;
/** 
Detector parameters. 
**/

public interface TestDataInfo {

   static final String[] testNames = {"ResetTest","RedundancyTest","FullBypassTest","PipelineTest",
                                      "StrobeDelayTest","3PtGainTest","TrimRangeTest","NPtGainTest",
				      "NoiseOccupancyTest","TimeWalkTest","LongTermTest","IVScanTest",
				      "NMaskTest", "RxThresholdTest", "RxThresholdBasedOnConfigRegisterTest",
				      "RxDelayTest","TxCurrentTest", "DoubleTriggerNoise","MarkSpaceRatioTest",
				      "ChipCounterTest",
				      "DefaultTest"};
// test names as they appear in menus
   static final String[] testMenuNames = {"Reset","Redundancy","FullByPass","Pipeline",
                                          "StrobeDelay","3PtGain","Trim","NPtGain",
					  "Noise","TimeWalk","LongTerm","IVscan",
					  "NMask","RxThreshold", "RxThresholdFromConfigReg",
					  "RxDelay", "TxCurrent","DoubleTriggerNoise","MarkSpaceRatio",
					  "ChipCounter",
					  "DefaultTest"};
// the keywords in the result summary files, excluding the initial '%'
   static final String[] resultFileKeyNames = {"","","FullBypassTest","PipelineTest",
                                               "StrobeDelay","ThreePointGain","Trim","ResponseCurve",
					       "NO","TimeWalkTest","","DetModIV",
					       "NMaskTest", "RxThreshold", "RxThresholdBasedOnConfigRegisterTest",
					       "RxDelay","TxCurrentTest","DoubleTriggerNoise","MarkSpaceRatioTest",
					       "ChipCounterTest",
					       "DefaultTest"};

   static final int parameterOffset=4;  // offset to chip data

   static final String[][] testParameters = {
                {},
                {},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","Token","RToken","Token Comment","RToken Comment"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","Defective pipelines"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","Strobe Delay"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","VT50(mV)","VT50(mV) RMS","Gain (mV/fC)","Gain RMS","Offset (mV)","Offset RMS","Output Noise (mV)","Input Noise (enc)","Noise RMS (enc)","ChipSlope Noise","ChipSlope Offset","ChipSlope Gain"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","Trim Range","Target","N(untrimmed)","VT50(mV)","VT50(mV) RMS","Offset (mV)","Offset RMS","Step size (mV)","Step Size RMS"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","VT50(mV)","VT50(mV) RMS","Gain (mV/fC)","Gain RMS","Offset (mV)","Offset RMS","Output Noise (mV)","Input Noise (enc)","Noise RMS (enc)","ChipSlope Noise","ChipSlope Offset","ChipSlope Gain"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","Offset (mV)","Occupancy","RMS Occupancy","Input Noise (enc)","MaxBadness","NoThreshold"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions","TimeWalk(ns)","TCal"},
                {},
                {},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions"},  // NMask - no other data
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Rx Threshold"},
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Min Rx Threshold","Max Rx Threshold","Best Rx Threshold"},
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Rx Delay"},
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Min Tx Current","Max Tx Current","Best Tx Current"},
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Average Occupancy","Peak Occupancy","Peak Ratio","Peak Bin"},
		{"Result Status","Defect Count","#Bad Chans","DCS Conditions","Optimum MS Ratio"},
                {"Result Status","Defect Count","#Bad Chans","DCS Conditions"},  // ChipCounter - no other data
                {}
         };
   static final boolean[][] doComparisons = {
                {},
                {},
                {false,false,false,false,true,true,false,false},
                {false,false,false,false,true},
                {false,false,false,false,true},
                {false,false,false,false,false,false,true,false,false,false,false,true,false,false,false,false},
                {false,false,false,false,false,false,true,false,false,false,false,false,false},
                {false,false,false,false,false,false,true,false,false,false,false,true,false,false,false,false},
                {false,false,false,false,false,true,false,true,false,false},
                {false,false,false,false,true,false},
                {},
                {},
                {false,false,false,false},  // NMask - no other data
		{false,false,false,false,false},
		{false,false,false,false,false,false,false,false},
		{false,false,false,false,false},
		{false,false,false,false,false,false,false},
		{false,false,false,false,false,false,false,false},
		{false,false,false,false,false},
                {false,false,false,false},  // ChipCounter - no other data
                {}
         };
	 
   static final boolean[][] isSCTDAQCompatible = {   // these test parameters are compatible with SCTDAQ, and therefore downloadable from the sct database
                {},
                {},
                {true,true,true,true,true,true,true,true},
                {true,true,true,true,true},
                {true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,false},
                {true,true,true,true,true,true,true,true,true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true,true,true,true,false,false,false},
                {true,true,true,true,true,true,true,true,false,false},
                {true,true,true,true,true,true},
                {},
                {},
                {false,false,false,false},  // NMask - no other data
		{false,false,false,false,false},
		{false,false,false,false,false,false,false,false},
		{false,false,false,false,false},
		{false,false,false,false,false,false,false,false},
		{false,false,false,false,false,false,false,false},
		{false,false,false,false,false},
                {false,false,false,false},  // ChipCounter - no other data
                {}
         };


   static final boolean[][] canBeZero = {
                {},
                {},
                {true,true,true,true,true,true,true,true},
                {true,true,true,true,true},
                {true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true},
                {true,true,true,true,true,true,true,true,true,true},
                {true,true,true,true,true,true},
                {},
                {},
                {true,true,true,true},  // NMask - no other data
		{true, true, true,true,true},
		{true, true, true,true,true,true,true,true},
		{true, true, true,true,true},
		{true, true, true,true,true,true,true,true},
		{true,true,true,true,true,true,true,true},
		{true,true,true,true,true},
                {true,true,true,true},  // ChipCounter - no other data
                {}
         };
   public double[][] testDataTolerances = {
                {},
                {},
                {0.0,0.0,0.0,0.0,0.1,0.1,1.0,1.0},
                {0.0,0.0,0.0,0.0,1.0},
                {0.0,0.0,0.0,0.0,3.0},
                {0.0,0.0,0.0,0.0,50.0,5.0,10.0,1.0,5.0,3.0,2.0,150.0,50.0,1.0,1.0,1.0},
                {0.0,0.0,0.0,0.0,4.0,200.0,1.0,100.0,10.0,100.0,20.0,10.0,1.0},
                {0.0,0.0,0.0,0.0,50.0,5.0,10.0,1.0,5.0,3.0,2.0,150.0,50.0,1.0,1.0,1.0},
                {0.0,0.0,0.0,0.0,10.0,5e-5,5e-5,150.0,0.0,0.0},
                {0.0,0.0,0.0,0.0,0.5,0.5},
                {},
                {},
                {0.0, 0.0,0.0,0.0,},
		{0.0, 0.0,0.0, 0.0,3.0},
		{0.0, 0.0,0.0, 0.0,3.0,3.0,3.0,3.0},
		{0.0, 0.0,0.0, 0.0,3.0},
		{0.0, 0.0,0.0, 0.0,3.0,3.0,3.0,3.0},
		{0.0, 0.0,0.0, 0.0,5e-5,5e-5,0.5,1.0},
		{0.0,0.0,0.0,0.0,0.0},
                {0.0, 0.0,0.0,0.0,},
                {}
          };

   public final String[] chipOptions = {"Chip Maximum","Chip Minimum","Mean (Link0)","Mean (Link1)","Chip M0","Chip S1","Chip S2","Chip S3","Chip S4","Chip E5","Chip M8",
"Chip S9","Chip S10","Chip S11","Chip S12","Chip E13"}; 

   public final String[] linkOptions = {"Link 0","Link 1"};

   public final String[] dcsOptions = {"Sensor HV(Volts)","Sensor Current(uA)","Hybrid T0(degC)","Hybrid T1(degC)","Chip VCC (Volts)","Chip ICC (mA)","Chip VDD (Volts)","Chip IDD (mA)","TDiff (degC)","Module Power (W)","Chip IPIN"};

   public final String[] dcsParams = {"HVchVolt","HVchCurr","MOch_Tm0","MOch_Tm1","LVch_Vcc","LVch_Icc","LVch_Vdd","LVch_Idd","LVchPINI"};

   public final String[] configParams = {"Module Group","TX Current","TX Coarse Delay","TX Fine Delay","Mark/Space","RX Threshold","RX Delay"};
   public final boolean[] configParams_links = {false,false,false,false,false,true,true};
   public final String[] configParamLabels = {"","ST_TX_CURRENT","ST_TX_COARSE","ST_TX_FINE","ST_TX_MARKSPACE","ST_RX_THRESHOLD","ST_RX_DELAY"};

   public static final int TEST_RESET=0;
   public static final int TEST_REDUNDANCY=1;
   public static final int TEST_FULLBYPASS=2;
   public static final int TEST_PIPELINE=3;
   public static final int TEST_STROBEDELAY=4;
   public static final int TEST_3PTGAIN=5;
   public static final int TEST_TRIM=6;
   public static final int TEST_NPTGAIN=7;
   public static final int TEST_NOISE=8;
   public static final int TEST_TIMEWALK=9;
   public static final int TEST_LONGTERM=10;
   public static final int TEST_IV=11;
   public static final int TEST_NMASK=12;
   public static final int TEST_RXTHRESHOLD=13;
   public static final int TEST_RXTHRESHOLDBASEDONCONFIGREGISTER=14;
   public static final int TEST_RXDELAY=15;
   public static final int TEST_TXCURRENT=16;
   public static final int TEST_DOUBLETRIGGERNOISE=17;
   public static final int TEST_MARKSPACERATIO=18;
   public static final int TEST_CHIPCOUNTER=19;
   public static final int TEST_DEFAULT=20;

   // test is compatible with SctRodDaq
   public final boolean[] testIsDefined = {false,false,true,true,true,true,true,true,true,true,false,false,true,true,true,true,true,true,true,true,false};
   // test is compatible with SCTDAQ
   public final boolean[] testIsSCTDAQ = {true,true,true,true,true,true,true,true,true,true,true,true,false,false,false,false,false,false,false,false,false};

}

